#include "StdAfx.h"
#include "HintWin.h"
#include "resource.h"
#include "../__MyLib__/Draw/DC.h"
#include "../__MyLib__/Draw/Bitmap.h"
#pragma comment(lib, "MsImg32") // GradientFill

#define DT_myFormat (DT_LEFT | DT_TOP | DT_NOCLIP/** /| DT_SINGLELINE | DT_VCENTER | /** /| DT_EDITCONTROL/**/)

int CHintWin::CXY = 54;
int CHintWin::OFF = 42;

#define ALTERNATIVE_GRADIENT TRUE
/*
    ALTERNATIVE_GRADIENT == TRUE,           
    ALTERNATIVE_GRADIENT != TRUE,         
*/

CHintWin::CHintWin() :
   m_hRgn(NULL)
{
   for (int i=0; i<3; i++)
      m_clrCursorPoint[i] = rand(0xFF00);//(0xFF>>rand(8)) << 8;
   m_clrBk[0] = RGB(0xF8,0xF8,0xC8);//::GetSysColor(COLOR_GRADIENTACTIVECAPTION); // COLOR_MENU
   m_clrBk[1] = RGB(0xF0,0xF0,0xA6);//::GetSysColor(COLOR_GRADIENTACTIVECAPTION); // COLOR_HIGHLIGHT
   for (int i=0; i<4; i++)
      for (int j=0; j<3; j++)
         m_clrGradText[i][j] = rand(0xFF00);//(0xFF>>rand(8)) << 8;

   static LOGFONT f = {12,0,0,0, FW_BOLD,0,0,0, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS,
                       CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
                       _T("MS Sans Serif")};// _T("Times New Roman")};//
   m_fntTitle.CreateFontIndirect(&f);
   f.lfHeight = 8;
   f.lfWeight = FW_NORMAL;
   m_fntDescr.CreateFontIndirect(&f);
}

void CHintWin::CreateRegionHint(SIZEEX newSizeWin) {
   if ((newSizeWin.cx <=0) || (newSizeWin.cy <= 0))
      return;

   //   '  '
   POINT pArr[] = {{0,0}, {CXY,OFF}, {newSizeWin.cx-OFF,OFF}, {newSizeWin.cx-OFF,newSizeWin.cy-OFF}, {OFF, newSizeWin.cy-OFF}, {OFF, CXY}};
   HRGN hRgn = ::CreatePolygonRgn(pArr, chDIMOF(pArr), WINDING);
   int iRes = SetWindowRgn(hRgn, TRUE); //    , ..     DeleteObject(m_hRgn)
   _ASSERT_EXPR(!!iRes, L"CHintWin::CreateRegionHint: SetWindowRgn(hRgn)");
   if (iRes != 0)
      m_hRgn = hRgn;
}

//#include "./Diagnostics/Helper.h"
LRESULT CHintWin::OnCreate(LPCREATESTRUCT lpCreateStruct) {
   //  -
   lpCreateStruct->cx =
   lpCreateStruct->cy = CW_USEDEFAULT;

   //OutputDebugString(nsHelper::WindowStyle(lpCreateStruct->style));
   //lpCreateStruct->style &= ~WS_VISIBLE;
   //OutputDebugString(nsHelper::WindowStyle(lpCreateStruct->style));

   //    
   SetTimer(ID_TIMER_REDRAW, 100);

   return 0;
}

void CHintWin::OnDestroy() {
   if (m_hRgn) {
      //  
      int iRes = SetWindowRgn(NULL, FALSE); //  m_hRgn.   m_hRgn       -
      _ASSERT_EXPR(!!iRes, L"CHintWin::OnDestroy: SetWindowRgn(NULL)");
      m_hRgn = NULL;
   }
}



void CHintWin::OnPaint(HDC /*hDC*/)
{
   CPaintDC pdc(m_hWnd);
   const RECTEX rcClient = ::GetClientRect(m_hWnd);

   //     ,      
   CDC dc; dc.CreateCompatibleDC(pdc);
   CBitmap bmp; bmp.CreateCompatibleBitmap(pdc, rcClient.width(), rcClient.height());
   CBitmapHandle bmpOld = dc.SelectBitmap(bmp);
   CFontT<false> oldFont = dc.SelectFont(m_fntTitle);

   CString strTitle = ::GetWindowText(m_hWnd);
   const SIZEEX sizeTitle = GetSizeMultiLine(dc, strTitle);
   dc.SelectFont(m_fntDescr); //   -  
   const SIZEEX sizeDescr = GetSizeMultiLine(dc, m_strDescr);

   const RECTEX rcTitle( //    Title
      OFF, OFF,
      OFF + (Indentation::FromEdge()<<1) + max(sizeTitle.cx, sizeDescr.cx),
      OFF + (Indentation::FromEdge()<<1) + sizeTitle.cy);
   const RECTEX rcDescr( //    Description
      OFF, rcTitle.bottom,
      OFF + rcTitle.width(),
      rcTitle.bottom + (Indentation::FromEdge()<<1) + sizeDescr.cy);
#if ALTERNATIVE_GRADIENT
   CDC dcGrad; dcGrad.CreateCompatibleDC(pdc);
   CBitmap bmpGrad; bmpGrad.CreateCompatibleBitmap(pdc, rcClient.width(), rcClient.height());
   CBitmapHandle bmpGradOld = dcGrad.SelectBitmap(bmpGrad);
   GradientFill(dcGrad, rcClient);
#endif

   _ASSERT(rcTitle.width()+(OFF<<1) == rcClient.width());
   _ASSERT(rcDescr.width()+(OFF<<1) == rcClient.width());
   _ASSERT(rcTitle.height()+rcDescr.height()+(OFF<<1) == rcClient.height());

#if 1
   // draw/fill hint area
   {
      //dc.FillSolidRect(&rcTitle, ::GetSysColor(COLOR_WINDOWFRAME)); dc.FillSolidRect(&rcDescr, ::GetSysColor(COLOR_WINDOWFRAME));
      const COLORREF &clrTop    = m_clrBk[0];
      const COLORREF &clrBottom = m_clrBk[1];
      TRIVERTEX vert[] = {
         {
            rcTitle.left,          // LONG    x;
            rcTitle.top,           // LONG    y;
            GetRValue(clrTop)<<8, // COLOR16 Red;   0x0000..0xff00
            GetGValue(clrTop)<<8, // COLOR16 Green;
            GetBValue(clrTop)<<8, // COLOR16 Blue;
            0x0000                // COLOR16 Alpha;
         }, {
            rcDescr.right,            // LONG    x;
            rcDescr.bottom,           // LONG    y;   
            GetRValue(clrBottom)<<8, // COLOR16 Red;   0x0000..0xff00
            GetGValue(clrBottom)<<8, // COLOR16 Green;
            GetBValue(clrBottom)<<8, // COLOR16 Blue;
            0x0000                   // COLOR16 Alpha;
         }
      };
      GRADIENT_RECT gRc[] = {{0, 1}};
      BOOL bRes = dc.GradientFill(vert, chDIMOF(vert), &gRc, 1, GRADIENT_FILL_RECT_V); _ASSERT_EXPR(bRes, L"CHintWin:OnPaint: dc.GradientFill");
   }
#endif
#if 1
   // draw border
   dc.Draw3dRect(&rcTitle,
      ::GetSysColor(COLOR_ACTIVEBORDER),//RGB(0,0,0),
      ::GetSysColor(COLOR_INACTIVEBORDER));//::GetSysColor(COLOR_HIGHLIGHT));//RGB(0,0,0));//
   dc.Draw3dRect(&rcDescr,
      ::GetSysColor(COLOR_ACTIVEBORDER),//RGB(0,0,0),
      ::GetSysColor(COLOR_INACTIVEBORDER));//::GetSysColor(COLOR_HIGHLIGHT));//RGB(0,0,0));//
#endif
#if 1
   // cursor gradient fill
   {
      TRIVERTEX vert[] = {
         {
            0,              // LONG    x;
            0,              // LONG    y;
            m_clrCursorPoint[0], // COLOR16 Red;   0x0000..0xff00
            m_clrCursorPoint[1], // COLOR16 Green;
            m_clrCursorPoint[2], // COLOR16 Blue;
            0x0000          // COLOR16 Alpha;
         }, {
            OFF,                  // LONG    x;
            CXY,                  // LONG    y;   
            GetRValue(m_clrBk[0])<<8, // COLOR16 Red;   0x0000..0xff00
            GetGValue(m_clrBk[0])<<8, // COLOR16 Green;
            GetBValue(m_clrBk[0])<<8, // COLOR16 Blue;
            0x0000                // COLOR16 Alpha;
         }, {
            CXY,                  // LONG    x;
            OFF,                  // LONG    y;   
            GetRValue(m_clrBk[1])<<8, // COLOR16 Red;   0x0000..0xff00
            GetGValue(m_clrBk[1])<<8, // COLOR16 Green;
            GetBValue(m_clrBk[1])<<8, // COLOR16 Blue;
            0x0000          // COLOR16 Alpha;
         }
      };
      GRADIENT_TRIANGLE gTri = {0, 1, 2}; //    
      BOOL bRes = dc.GradientFill(vert, chDIMOF(vert), &gTri, 1, GRADIENT_FILL_TRIANGLE); _ASSERT_EXPR(bRes, L"CHintWin:OnPaint: dc.GradientFill");
   }
#endif
#if 1 // draw text
   {
      m_setResult.clear();

   #if 1 // draw Title
      {
         strTitle.Replace(_T("\r\n"), _T("\n"));
         if (!strTitle.IsEmpty()) {
            RECTEX rcTxt(
               rcTitle.left + Indentation::FromEdge(),
               rcTitle.top + Indentation::FromEdge(),
               rcTitle.left + Indentation::FromEdge() + sizeTitle.cx, // rcTitle.right - Indentation::FromEdge(),
               rcTitle.bottom - Indentation::FromEdge());
               
            int iOldBk = dc.SetBkMode(TRANSPARENT);
            COLORREF oldColor = dc.GetTextColor(); // save old color
            dc.SetTextColor(::GetSysColor(COLOR_GRAYTEXT));//RGB(0xFF,0,0));
            dc.SelectFont(m_fntTitle);

         #if 0
            // draw as is
            DrawText(dc, strTitle, rcTxt);
         #else
            {
               std::vector<CString> arrTxt = ::Split(strTitle, _T("\n"));

               for (size_t i=0; i<arrTxt.size(); i++) {
                  SIZEEX sizeSingleLine = GetSizeSingleLine(dc, arrTxt[i]);

                  if (sizeSingleLine.cx && sizeSingleLine.cy) {
                     RECTEX rcSingleLine = rcTxt;
                     rcSingleLine.right = rcSingleLine.left + sizeSingleLine.cx;
                     rcSingleLine.bottom = rcSingleLine.top + sizeSingleLine.cy;
               #if 0
                     //  -  
                     DrawGradientText(dc, arrTxt[i], rcSingleLine);
               #else
                     //  -  ,    -  
                     DrawText(dc, arrTxt[i], rcSingleLine);

                     std::vector<__tmpRegExParseReturn> result;
                     if (FindHighlightErrCode(arrTxt[i], result))
                        for (size_t j=0; j<result.size(); j++) {
                           CString strFirst = arrTxt[i].Left(result[j].first);
                           CString strLast = arrTxt[i].Left(result[j].first+result[j].second);
                           SIZEEX sizeFirst = GetSizeSingleLine(dc, strFirst);
                           SIZEEX sizeLast = GetSizeSingleLine(dc, strLast);
                           _ASSERT(sizeFirst.cx < sizeLast.cx);

                           RECTEX rcSubLine = rcSingleLine;
                           rcSubLine.right = rcSingleLine.left + sizeLast.cx;
                           rcSubLine.left = rcSingleLine.left + sizeFirst.cx;
                           CString str = arrTxt[i].Mid(result[j].first).Left(result[j].second);

                           m_setResult.insert(str);

                           if (result[j].first)
                              rcSubLine.moveX(-1); //     -1 :(
                     #if ALTERNATIVE_GRADIENT
                           DrawGradientText(dc, str, rcSubLine, dcGrad);
                     #else
                           DrawGradientText(dc, str, rcSubLine);
                     #endif
                        }
               #endif
                  }
                  rcTxt.top += sizeSingleLine.cy+Indentation::BetweenLines();
               }
            }
         #endif

            // restore
            dc.SetBkMode(iOldBk);
            dc.SetTextColor(oldColor);
         }
      }
   #endif // draw  Title
   #if 1 // draw Description
      {
         CString strDescr(m_strDescr);
         strDescr.Replace(_T("\r\n"), _T("\n"));
         if (!strDescr.IsEmpty()) {
            RECTEX rcTxt(
               rcDescr.left + Indentation::FromEdge(),
               rcDescr.top + Indentation::FromEdge(),
               rcDescr.left + Indentation::FromEdge() + sizeDescr.cx, // rcDescr.right - Indentation::FromEdge(),
               rcDescr.bottom - Indentation::FromEdge());
               
            int iOldBk = dc.SetBkMode(TRANSPARENT);
            COLORREF oldColor = dc.GetTextColor(); // save old color
            dc.SetTextColor(::GetSysColor(COLOR_GRAYTEXT));//RGB(0xFF,0,0));
            dc.SelectFont(m_fntDescr);

         #if 0
            // draw as is
            DrawText(dc, strDescr, rcTxt);
         #else
            {
               std::vector<CString> arrTxt = ::Split(strDescr, _T("\n"));

               for (size_t i=0; i<arrTxt.size(); i++) {
                  SIZEEX sizeSingleLine = GetSizeSingleLine(dc, arrTxt[i]);

                  if (sizeSingleLine.cx && sizeSingleLine.cy) {
                     //RECTEX rcSingleLine = rcTxt;
                     //rcSingleLine.right = rcSingleLine.left + sizeSingleLine.cx;
                     //rcSingleLine.bottom = rcSingleLine.top + sizeSingleLine.cy;
                     //DrawText(dc, arrTxt[i], rcSingleLine);
                     DrawText(dc, arrTxt[i], rcTxt);
                  }
                  rcTxt.top += sizeSingleLine.cy+Indentation::BetweenLines();
               }
            }
         #endif

            // restore
            dc.SetBkMode(iOldBk);
            dc.SetTextColor(oldColor);
         }
      }
   #endif // draw Description
   }
#endif

   ::BitBlt(pdc, rcClient, dc, SRCCOPY); // copy
   //::BitBlt(pdc, rcClient, dcGrad, SRCCOPY); // test - debug gradient

   // restore
#if ALTERNATIVE_GRADIENT
   dcGrad.SelectBitmap(bmpGradOld);
#endif
   dc.SelectBitmap(bmpOld);
   dc.SelectFont(oldFont);
}

SIZE CHintWin::GetSizeSingleLine(CDC &dc, const CString &str) const {
   RECTEX rc;
   int iRes = dc.DrawText(str, str.GetLength(), &rc, DT_myFormat | DT_CALCRECT); _ASSERT(iRes!=0);
   return rc;
}

SIZE CHintWin::GetSizeMultiLine(CDC &dc, const CString &str) const {
   CString str2(str);
   str2.Replace(_T("\r\n"), _T("\n"));

   SIZEEX sizeAll;
   std::vector<CString> arrLines = ::Split(str2, _T("\n"));
   for (size_t i=0; i<arrLines.size(); i++) {
      SIZEEX size = GetSizeSingleLine(dc, arrLines[i]); //BOOL bRes = dc.GetTextExtent(arrTxt[i], arrTxt[i].GetLength(), &size); _ASSERT(bRes);
      sizeAll.cx = max(size.cx, sizeAll.cx);
      sizeAll.cy += size.cy;
   }
   sizeAll.cy += (arrLines.size()-1)*Indentation::BetweenLines(); //   

   return sizeAll;
}

BOOL CHintWin::GradientFill(CDC &dc, const RECTEX &rc) const {
   // gradient
   TRIVERTEX vert[] = {
      {
         rc.left,       // LONG    x;
         rc.top,        // LONG    y;
         m_clrGradText[0][0],  // COLOR16 Red;   0x0000..0xff00
         m_clrGradText[0][1],  // COLOR16 Green;
         m_clrGradText[0][2],  // COLOR16 Blue;
         0x0000             // COLOR16 Alpha;
      }, {
         rc.left,       // LONG    x;
         rc.bottom,     // LONG    y;   
         m_clrGradText[1][0],  // COLOR16 Red;   0x0000..0xff00
         m_clrGradText[1][1],  // COLOR16 Green;
         m_clrGradText[1][2],  // COLOR16 Blue;
         0x0000             // COLOR16 Alpha;
      }, {
         rc.right,      // LONG    x;
         rc.bottom,     // LONG    y;   
         m_clrGradText[2][0],  // COLOR16 Red;   0x0000..0xff00
         m_clrGradText[2][1],  // COLOR16 Green;
         m_clrGradText[2][2],  // COLOR16 Blue;
         0x0000             // COLOR16 Alpha;
      }, {
         rc.right,      // LONG    x;
         rc.top,        // LONG    y;   
         m_clrGradText[3][0],  // COLOR16 Red;   0x0000..0xff00
         m_clrGradText[3][1],  // COLOR16 Green;
         m_clrGradText[3][2],  // COLOR16 Blue;
         0x0000             // COLOR16 Alpha;
      }
   };
   for (UINT i=0; i<chDIMOF(vert); i++) {
      //const COLOR16 or = 0x00FF; //  
      //vert[i].Blue |= or; vert[i].Green |= or; vert[i].Red |= or;
      const COLOR16 and = 0xBFFF; //    
      vert[i].Blue &= and; vert[i].Green &= and; vert[i].Red &= and;
   }
   GRADIENT_TRIANGLE gTri1[] = {{1, 0, 3}, {3, 2, 1}};
   GRADIENT_TRIANGLE gTri2[] = {{0, 1, 2}, {0, 3, 2}};
   BOOL bRes = dc.GradientFill(vert, chDIMOF(vert), (true) ? &gTri1 : &gTri2, 2, GRADIENT_FILL_TRIANGLE); _ASSERT(bRes);
   return bRes;
}

void CHintWin::DrawGradientText(CDC &dc, const CString &str, const RECTEX &rc) const {
   //   DC   
   //   

   CDC dc2; dc2.CreateCompatibleDC(dc);
   CDC dc3; dc3.CreateCompatibleDC(dc);
   //CBitmap bmpMono; bmpMono.Attach(::CreateBitmapMono(rcLine));
   CBitmap bmp2; bmp2.CreateCompatibleBitmap(dc, rc.width(), rc.height());
   CBitmap bmp3; bmp3.CreateCompatibleBitmap(dc, rc.width(), rc.height());
   CBitmapHandle bmpOld2 = dc2.SelectBitmap(bmp2);//dc2.SelectBitmap(bmpMono);//
   CBitmapHandle bmpOld3 = dc3.SelectBitmap(bmp3);
   CFontT<false> oldFont2 = dc2.SelectFont(m_fntTitle);

   // text as mask
   RECTEX rcLine = rc.size();
   DrawText(dc2, str, rcLine);
   // gradient
   GradientFill(dc3, rcLine);

   ::BitBltMasked(dc3, rcLine, dc2, POINTEX(), 0x000000); //     ( - ,  - )
   ::BitBltMasked(dc, rc, dc3, POINTEX(), 0xFFFFFF); //   

   // restore
   dc2.SelectFont(oldFont2);
   dc2.SelectBitmap(bmpOld2);
   dc3.SelectBitmap(bmpOld3);
}

void CHintWin::DrawGradientText(CDC &dc, const CString &str, const RECTEX &rc, CDC &dcGrad) const {
   //   DC   
   //   

   CDC dc2; dc2.CreateCompatibleDC(dc);
   //CBitmap bmpMono; bmpMono.Attach(::CreateBitmapMono(rcLine));
   CBitmap bmp2; bmp2.CreateCompatibleBitmap(dc, rc.width(), rc.height());
   CBitmapHandle bmpOld2 = dc2.SelectBitmap(bmp2);//dc2.SelectBitmap(bmpMono);//
   CFontT<false> oldFont2 = dc2.SelectFont(m_fntTitle);

   // text as mask
   RECTEX rcLine = rc.size();
   DrawText(dc2, str, rcLine);

   ::BitBltMasked(dcGrad, rc, dc2, POINTEX(), 0x000000); //     ( - ,  - )
   ::BitBltMasked(dc, rc, dcGrad, rc.pointLT(), 0xFFFFFF); //   

   // restore
   dc2.SelectFont(oldFont2);
   dc2.SelectBitmap(bmpOld2);
}

void CHintWin::DrawText(CDC &dc, const CString &str, const RECTEX &rc) const {
   int iRes = dc.DrawText(str, str.GetLength(), const_cast<RECT*>((RECT*)&rc), DT_myFormat); _ASSERT(iRes!=0);
}

void CHintWin::OnTimer(UINT nIDEvent/*, TIMERPROC /*tmprc*/) {
   if (nIDEvent == ID_TIMER_REDRAW) {
      DWORD dwTC = ::GetTickCount();
      {
         int j = (dwTC>>5)%3;
         COLOR16 &v = m_clrCursorPoint[j];
         v = ((dwTC & 1) ? 0x0000 : 0x8000) | (v>>1);
         //v = (((dwTC & 1) ? 0x00 : 0x80) | ((v>>8)>>1))<<8;
      }
      for (UINT i=0; i<4; i++)
      {
         //int i = (dwTC>>1)%4;
         //int j = (dwTC>>(i<<1))%3;//int j = (dwTC>>2)%3;
         int j = (dwTC>>rand(0xF))%3;
         COLOR16 &v = m_clrGradText[i][j];
         v = ((dwTC & 1) ? 0x0000 : 0x8000) | (v>>1);
         //v = (((dwTC & 1) ? 0x00 : 0x80) | ((v>>8)>>1))<<8;
      }
      InvalidateRect(NULL, FALSE);
   }
}

void CHintWin::OnWindowPosChanging(LPWINDOWPOS lpWndPos) {
   if (!lpWndPos) return;
   CreateRegionHint(SIZEEX(lpWndPos->cx, lpWndPos->cy));
}
void CHintWin::OnWindowPosChanged(LPWINDOWPOS lpWndPos) {
   //if (!lpWndPos) return;
   //SIZEEX size(lpWndPos->cx, lpWndPos->cy);
   //::OutputDebugString(::Format(_T("CHintWin::OnWindowPosChanged: new size=[%i, %i] \n"), size.cx, size.cy));
}
void CHintWin::ApplyChangeText(LPCTSTR lpstrText) {
   SIZEEX sizeAll;

   { //         
      CClientDC dc(m_hWnd);
      CFontT<false> oldFont = dc.SelectFont(m_fntTitle);

      SIZEEX sizeTitle = GetSizeMultiLine(dc, lpstrText);
      dc.SelectFont(m_fntDescr); //   -  
      SIZEEX sizeDescr = GetSizeMultiLine(dc, m_strDescr);

      sizeAll.cx = max(sizeTitle.cx, sizeDescr.cx) + (OFF<<1) + (Indentation::FromEdge()<<1); //          
      sizeAll.cy =    (sizeTitle.cy +sizeDescr.cy) + (OFF<<1) + (Indentation::FromEdge()<<2);

      // restore
      dc.SelectFont(oldFont);
   }

   //   CreateRegionHint  WM_WINDOWPOSCHANGING
   BOOL bRes = SetWindowPos(NULL, &RECTEX(sizeAll), SWP_NOZORDER | SWP_NOMOVE | SWP_ASYNCWINDOWPOS); _ASSERT(bRes);
}

//BOOL GetTextExtentPoint32Adj(HDC hDC, LPCTSTR lpStr, DWORD dwLen, SIZE &size, BOOL maxSize)
//{
//   ABC abc;
//   if (!::GetTextExtentPoint32(hDC, lpStr, dwLen, &size))
//      return FALSE;
//   if (!::GetCharABCWidths(hDC, lpStr[0], lpStr[0], &abc))
//      return FALSE;
//   if (maxSize || abc.abcA < 0)
//      size.cx -= abc.abcA;
//   if(!::GetCharABCWidths(hDC, lpStr[dwLen-1], lpStr[dwLen-1], &abc))
//      return FALSE;
//   if (maxSize || abc.abcC < 0 )
//      size.cx -= abc.abcC;
//   return TRUE;
//}

#if SUPPORT_BOOST_REGEX
   #ifdef _UNICODE
      typedef std::wstring tstring;
      typedef boost::wregex tregex;
      typedef boost::wsmatch tsmatch;
      typedef boost::wsregex_iterator tsregex_iterator;
   #else
      typedef std::string tstring;
      typedef boost::regex tregex;
      typedef boost::smatch tsmatch;
      typedef boost::sregex_iterator tsregex_iterator;
   #endif
#endif
BOOL CHintWin::FindHighlightErrCode(IN const CString &str, OUT std::vector<__tmpRegExParseReturn> &result) const {
   result.clear();

#if ! SUPPORT_BOOST_REGEX
   //return FALSE;
   // test
   BOOL bRes = !str.IsEmpty();
   if (bRes) {
      CString strFind = _T(" ");
      int iFirst = str.Find(strFind);
      bRes = (iFirst != -1);
      if (bRes) {
         iFirst += strFind.GetLength();
         int iLast = str.Find(strFind, iFirst+strFind.GetLength());
         if (iLast == -1) {
            iLast = str.GetLength()-1;
         }
         iLast += strFind.GetLength();

         result.push_back(__tmpRegExParseReturn(iFirst, iLast-iFirst+1));
      }
   }
   return bRes;
#else

   tstring src = (LPCTSTR)str; // A(W)TL::CString -> std::(w)string

   // see:
   //   http://habrahabr.ru/blogs/cpp/64226/
   //   http://ru.wikipedia.org/wiki/%D0%A0%D0%B5%D0%B3%D1%83%D0%BB%D1%8F%D1%80%D0%BD%D1%8B%D0%B5_%D0%B2%D1%8B%D1%80%D0%B0%D0%B6%D0%B5%D0%BD%D0%B8%D1%8F
   //   http://ru.wikipedia.org/wiki/%D0%9F%D1%80%D0%B5%D0%B4%D1%81%D1%82%D0%B0%D0%B2%D0%BB%D0%B5%D0%BD%D0%B8%D0%B5_%D1%81%D0%B8%D0%BC%D0%B2%D0%BE%D0%BB%D0%BE%D0%B2_%D0%B2_%D1%80%D0%B5%D0%B3%D1%83%D0%BB%D1%8F%D1%80%D0%BD%D1%8B%D1%85_%D0%B2%D1%8B%D1%80%D0%B0%D0%B6%D0%B5%D0%BD%D0%B8%D1%8F%D1%85

   // Hex
   //tregex xRegEx(_T("(0x[\\dA-Fa-f]{8})+")); // 0x123ABC56
   //tregex xRegEx(_T("([\\dA-Fa-f]{8})+")); // 123ABC56

   // Dec
   //tregex xRegEx(_T("([-+]{1}[\\d]{1,10})+")); //    
   //tregex xRegEx(_T("([\\d]{1,10})+")); //  

   // all
   //tregex xRegEx(_T("(0x[\\dA-Fa-f]{8})+|([\\dA-Fa-f]{8})+|([-+]{1}[\\d]{1,10})+|([\\d]{1,10})+")); // hex and dec
   CString strRegEx = ::LoadStringResource(IDS_REG_EXP_FIND_ERRCODES);
   tregex xRegEx(strRegEx); // hex and dec

   tsregex_iterator xIt(src.begin(), src.end(), xRegEx);
   tsregex_iterator xInvalidIt;
   while (xIt != xInvalidIt) {
      const boost::match_results<tstring::const_iterator> &mr = *xIt;
      _ASSERT(mr[0].matched);

      const tstring &findet = (mr[0]); //     sub_match    
      _ASSERT(!findet.empty());

      int iPos = mr.position();
      result.push_back(__tmpRegExParseReturn(iPos, findet.length()));

      xIt++;
   }
   BOOL bFinded = !result.empty();

#ifdef _DEBUG
   //if (!bFinded) {
   //   ::OutputDebugStr(_T("------\n not found \n------\n"));
   //} else {
   //   ::OutputDebugStr(_T("------\n"));

   //   for(size_t i=0; i<result.size(); i++) {
   //      ::OutputDebugString(str.Mid(result[i].first).Left(result[i].second));
   //      ::OutputDebugString(_T("\n"));
   //   }
   //   //std::for_each(result.begin(), result.end(), ::OutputDebugString);

   //   ::OutputDebugStr(_T("------\n"));
   //}
#endif

   return bFinded;
#endif
}