// Modeless dialog - hint text
// Copyright (C) 2010 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#pragma once
#include "../__MyLib__/CommonLib.h"
#include <set>

class CHintWin : public CWindowImpl<CHintWin, CWindow, CWinTraits<WS_POPUP | WS_VISIBLE, WS_EX_NOACTIVATE /*| WS_EX_TRANSPARENT*/> >
{
public:
   typedef std::set<CString> ResultErrorCodes;

private:
   static int CXY; //  ,    
   static int OFF; //   

   struct Indentation {
      static UINT BetweenLines() { return 3; } //   
      static UINT FromEdge() { return 6; } // CXY-OFF; } //   
   };

private:
   HRGN m_hRgn;
   COLOR16 m_clrCursorPoint[3]; //  
   COLORREF m_clrBk[2]; // top & bottom;
   COLOR16 m_clrGradText[4][3];
   CString m_strDescr;

   ResultErrorCodes m_setResult;

	enum {
		ID_TIMER_REDRAW = 123
	};
   CFont m_fntTitle, m_fntDescr;

public:
   DECLARE_WND_CLASS(_T("CHintWin"))

private:
   BEGIN_MSG_MAP_EX(CHintWin)
      MSG_WM_CREATE       (OnCreate)
      MSG_WM_DESTROY      (OnDestroy)
      MSG_WM_ERASEBKGND   (OnEraseBkgnd)
      MSG_WM_PAINT        (OnPaint)
      MSG_WM_TIMER        (OnTimer)
      MSG_WM_MOUSEACTIVATE(OnMouseActivate)
      MSG_WM_NCHITTEST    (OnNCHitTest)
      MSG_WM_WINDOWPOSCHANGING(OnWindowPosChanging)
      //MSG_WM_WINDOWPOSCHANGED(OnWindowPosChanged)
      MSG_WM_SETTEXT(OnSetText)
   END_MSG_MAP()

public:
   CHintWin();

private:
   void CreateRegionHint(SIZEEX newSizeWin);
   LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct);
   void OnDestroy();
   BOOL OnEraseBkgnd(CDCHandle dc) { return TRUE; }
   void OnPaint(HDC /*hDC*/);
   void OnTimer(UINT nIDEvent/*, TIMERPROC /*tmprc*/);
   int OnMouseActivate(HWND /*hDesktopWnd*/, UINT /*nHitTest*/, UINT /*message*/) { return MA_NOACTIVATE; }
   UINT OnNCHitTest(const CPoint& /*point*/) { return HTTRANSPARENT; }

   void OnWindowPosChanging(LPWINDOWPOS lpWndPos);
   void OnWindowPosChanged(LPWINDOWPOS lpWndPos);
   int OnSetText(LPCTSTR lpstrText) { SetMsgHandled(FALSE); ApplyChangeText(lpstrText); return FALSE; }
   void ApplyChangeText(LPCTSTR lpstrText);
public:
   void SetDescription(LPCTSTR szDescription) { m_strDescr = szDescription; ApplyChangeText(::GetWindowText(m_hWnd)); }
   ResultErrorCodes GetResult() const { return m_setResult; }

private:
   SIZE GetSizeSingleLine(CDC &dc, const CString &str) const;
   SIZE GetSizeMultiLine(CDC &dc, const CString &str) const;
   BOOL GradientFill(CDC &dc, const RECTEX &rc) const;
   void DrawGradientText(CDC &dc, const CString &str, const RECTEX &rc) const;
   void DrawGradientText(CDC &dc, const CString &str, const RECTEX &rc, CDC &dcGrad) const;
   void DrawText(CDC &dc, const CString &str, const RECTEX &rc) const;

   typedef std::pair< INT /* regex finded string Pos */, UINT /* regex finded string Len */> __tmpRegExParseReturn;
   //struct __tmpRegExParseReturn : public std::pair<INT, UINT> {
   //    INT getPos() const { return first; }
   //   UINT getLen() const { return second; }
   //};
   BOOL FindHighlightErrCode(IN const CString &str, OUT std::vector<__tmpRegExParseReturn> &result) const;
};