// MainDlg.cpp : implementation of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "MainDlg.h"
#include "../__MyLib__/Diagnostics/Helper.h"
#include "../__MyLib__/Resources.h"

//void CMainDlg::OnCommand(UINT codeNotify, int idControl, HWND /*hwndCtl*/) {
//   ::OutputDebugString(nsHelper::WindowMessage(codeNotify));
//   ::OutputDebugString(_T("\n"));
//}

#define ICO_DEF_SIZE           64
#define ICO_PROJ_SIZE_FULL_X   64 // 128 // 32 // ::GetSystemMetrics(SM_CXICON)   //
#define ICO_PROJ_SIZE_FULL_Y   64 // 128 // 32 // ::GetSystemMetrics(SM_CYICON)   //
#define ICO_PROJ_SIZE_SMALL_X  32 //  64 // 16 // ::GetSystemMetrics(SM_CXSMICON) //
#define ICO_PROJ_SIZE_SMALL_Y  32 //  64 // 16 // ::GetSystemMetrics(SM_CYSMICON) //

#define LANG1 MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)
#define LANG2 MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US)

BOOL CMainDlg::OnInitDialog(HWND /*hwndFocus*/, LPARAM /*lParam*/)
{
   m_bStartSearchWindow = FALSE;
   m_hWndFound = NULL;
   m_dwLastClickOnEditBoxDescr = m_dwLastLastClickOnEditBoxDescr = 0;
   m_bErrCodeDescrSysMsg = TRUE;
   m_dwLanguageId = LANG1;

   // center the dialog on the screen
	CenterWindow();
   
   DoDataExchange();

   // load form resource
	m_Icon.LoadIcon(MAKEINTRESOURCE(IDI_MAINFRAME), ICO_PROJ_SIZE_FULL_X, ICO_PROJ_SIZE_FULL_Y, LR_DEFAULTCOLOR);
	m_IconSmall.LoadIcon(MAKEINTRESOURCE(IDI_MAINFRAME), ICO_PROJ_SIZE_SMALL_X, ICO_PROJ_SIZE_SMALL_Y, LR_DEFAULTCOLOR);

   { //      
      CString strAniFile = ::GetTempPath() + _T("SearchErrLkp.ani");
      BOOL bRes = ::ExtractResource(ModuleHelper::GetResourceInstance(), _T("ANIMATED"), MAKEINTRESOURCE(IDA_SEARCH), strAniFile);
      if (bRes) {
         m_CursorSearch.Attach((HCURSOR)::LoadImage(NULL, strAniFile, IMAGE_CURSOR, ICO_DEF_SIZE, ICO_DEF_SIZE, LR_LOADFROMFILE)); //cursorAniSearch.LoadCursorFromFile(strAniFile);
         bRes = ::DeleteFile(strAniFile); _ASSERT(bRes);
      }
      if (m_CursorSearch.IsNull()) {
         //  -  
         m_CursorSearch.LoadCursor(MAKEINTRESOURCE(IDC_SEARCH), ICO_DEF_SIZE,ICO_DEF_SIZE, LR_DEFAULTCOLOR);
      }
   }
   m_RectanglePen.CreatePen(PS_SOLID, 3, RGB(256, 0, 0));
   m_IcoWin.LoadIcon(MAKEINTRESOURCE(IDI_WIN), ICO_DEF_SIZE,ICO_DEF_SIZE, LR_DEFAULTCOLOR);

	// set icons
	SetIcon(m_Icon, TRUE);
	SetIcon(m_IconSmall, FALSE);

#ifdef _DEBUG
   m_cbxErrCode.AddString(_T("12345"));
   //m_cbxErrCode.AddString(_T("E_FAIL"));
   m_cbxErrCode.AddString(_T("0x8004000F")); // OLE_E_INVALIDHWND
   m_cbxErrCode.AddString(_T("0x80004005")); // E_FAIL
#endif

   m_HintWin.Create(::GetDesktopWindow(), CWindow::rcDefault,  //   ::GetDesktopWindow() (   m_hWnd)  , 
                    _T("Gradient cursor 'Finder'"), WS_POPUP); //  m_HintWin.SetWindowPos(HWND_TOP)      this 

   //SetForegroundWindow(m_hWnd);
   //SetFocus();

	return TRUE;
}

void CMainDlg::OnDestroy() {
   //  , ..  m_HintWin.Create(::GetDesktopWindow()),   m_HintWin.Create(m_hWnd)
   BOOL bRes = m_HintWin.DestroyWindow(); _ASSERT(bRes);
}

void CMainDlg::OnClose(UINT uNotifyCode, int nID, CWindow wndCtl)
{
   EndDialog(nID);
}

BOOL CMainDlg::GetErrCodeValAsDec(OUT LONG &valDec) {
   const CString title = ::GetWindowText(m_cbxErrCode.m_hWnd);
   if ((title.GetLength() > 1) && (title[0]==_T('0'))) {
      //      ,      
   } else {
      HRESULT hRes = E_FAIL;
      valDec = ::toLong(title, hRes);
      return SUCCEEDED(hRes);
   }
   return FALSE;
}

BOOL CMainDlg::GetErrCodeValAsHex(OUT LONG &valHex) {
   BOOL isHex = FALSE;
   const CString title = ::GetWindowText(m_cbxErrCode.m_hWnd);
   if (title.GetLength() <= 11) {
      CString newTitle;
      if ((title.GetLength() > 2) &&
          (title[0]==_T('0')) &&
          (title[1]==_T('X') || title[1]==_T('x')))
      {
         newTitle = _T("0x")+title.Mid(2).SpanIncluding(_T("0123456789abcdefABCDEF"));
      } else {
         newTitle = title.SpanIncluding(_T("0123456789abcdefABCDEF"));
      }
      isHex = (title.CompareNoCase(newTitle) == 0);
      if (isHex) {
         valHex = ::toLongX(newTitle);
         isHex = (valHex != 0) || (errno == 0);
         _ASSERT(isHex);
      }
   }
   return isHex;
}

void CMainDlg::OnEditChangeErrCode(UINT /*wNotifyCode*/, int /*idControl*/, CWindow /*wndCtl*/) {
   //if (::GetWindowStyle(m_cbxErrCode.m_hWnd) & ES_READONLY)
   //   return;

   // clean others
   m_edtName.SetWindowText(_T(""));
   m_edtDscr.SetWindowText(_T(""));
   m_statIcoWarn.ShowWindow(FALSE);
   m_chkbxIsHex.ShowWindow(FALSE);

   const CString title = ::GetWindowText(m_cbxErrCode.m_hWnd);

   if (!title.IsEmpty()) {
      LONG valDec = 0L, valHex = 0L;
      BOOL isDec = GetErrCodeValAsDec(valDec);
      BOOL isHex = GetErrCodeValAsHex(valHex);

      if (!isDec && !isHex)
         m_statIcoWarn.ShowWindow(TRUE);
      else {
         m_chkbxIsHex.ShowWindow(TRUE);
         m_chkbxIsHex.SetCheck(isDec ? BST_UNCHECKED : BST_CHECKED); //    
         m_chkbxIsHex.EnableWindow(isDec && isHex); //   

         BOOL bHexChecked = !!(m_chkbxIsHex.GetState() & BST_CHECKED);
         _ASSERT(bHexChecked != isDec);
         LONG val = bHexChecked ? valHex : valDec;

         m_edtName.SetWindowText(nsHelper::ErrCode(val, FALSE, m_bErrCodeDescrSysMsg, m_dwLanguageId));
         m_edtDscr.SetWindowText(nsHelper::ErrCode(val, TRUE , m_bErrCodeDescrSysMsg, m_dwLanguageId));
      }
   }
}

void CMainDlg::OnChangeTypeValue(UINT uNotifyCode, int nID, CWindow wndCtl) {
   bool bHexChecked = !!(m_chkbxIsHex.GetState() & BST_CHECKED);
   LONG val = 0L;
   BOOL bOk = bHexChecked ? GetErrCodeValAsHex(val) : GetErrCodeValAsDec(val);
   _ASSERT_EXPR(bOk, L"    -       OnChangeErrCode");
   if (bOk) {
      m_edtName.SetWindowText(nsHelper::ErrCode(val, FALSE, m_bErrCodeDescrSysMsg, m_dwLanguageId));
      m_edtDscr.SetWindowText(nsHelper::ErrCode(val, TRUE , m_bErrCodeDescrSysMsg, m_dwLanguageId));
   }
}

void CMainDlg::OnStartFinder() {
   m_bStartSearchWindow = TRUE;

   // Display the empty window bitmap image in the Finder Tool static control.
   m_statIcoFinder.SetIcon(m_IcoWin);
   m_statIcoFinder.SetWindowPos(NULL, &RECTEX(0,0,ICO_DEF_SIZE,ICO_DEF_SIZE), SWP_NOZORDER | SWP_NOMOVE);

   //MoveCursorPositionToBullsEye (hwndDialog);

   // Set the screen cursor to the BullsEye cursor.
   SetCursor(m_CursorSearch);

   // Very important : capture all mouse activities from now onwards and
   // direct all mouse messages to the "Search Window" dialog box procedure.
   SetCapture();

   // Hide the main window.
   //ShowWindow(SW_HIDE);
   SetWindowPos(HWND_BOTTOM, &RECTEX(), SWP_NOMOVE | SWP_NOSIZE);
}

BOOL CMainDlg::EnumChild(HWND hWndChild) {
#if 1
   HWND hWndParent = ::GetParent(hWndChild);
   static HWND hWndParentPrev = NULL;
   if (hWndParentPrev != hWndParent)
      ::OutputDebugString(_T("-----------------------------------------------------\r\n"));
   ::OutputDebugString(
      ::Format(
         _T("   CMainDlg::EnumChild: parent=0x%08X, hWndChild=0x%08X; class=[%s]; title=[%s]; style=[%s]; exStyle=[%s] \r\n"),
         hWndParent, hWndChild, (LPCTSTR)::GetClassName(hWndChild), (LPCTSTR)::GetWindowText(hWndChild),
         (LPCTSTR)nsHelper::WindowStyle(hWndChild), (LPCTSTR)nsHelper::WindowStyleEx(hWndChild)
         ));

   hWndParentPrev = hWndParent;
#endif

   if (::IsWindowVisible(hWndChild)) {
      RECTEX rcChild = ::GetWindowRect(hWndChild);
      POINTEX sceenCurPos = GetCursorPos();

      bool inside = sceenCurPos.x > rcChild.left && sceenCurPos.x < rcChild.right &&
                    sceenCurPos.y > rcChild.top && sceenCurPos.y < rcChild.bottom;

      //_ASSERT_EXPR(!inside, L"!");
   }

   return TRUE;
}

void CMainDlg::OnRunFinder() {
   POINTEX sceenCurPos = GetCursorPos();
   SetWindowText(::Format(_T("%s mouse[%i, %i]"), ::LoadStringResource(IDS_MAINFRAME), sceenCurPos.x, sceenCurPos.y));

   // Determine the window that lies underneath the mouse cursor.
   HWND hWndFound = WindowFromPoint(sceenCurPos);

   // Check first for validity.
   if (CheckWindowValidity(hWndFound))
   {
      //::EnumChildWindows(hWndFound, CMainDlg::EnumChild, (LPARAM)this);
      m_HintWin.ShowWindow(SW_SHOWNOACTIVATE);
      m_HintWin.SetWindowPos(HWND_TOPMOST, &RECTEX(), SWP_NOMOVE | SWP_NOSIZE);

      // We have just found a new window.
      
      // If there was a previously found window, we must instruct it to refresh itself. 
      // This is done to remove any highlighting effects drawn by us.
      RefreshFoundWindow();

      // Indicate that this found window is now the current global found window.
      m_hWndFound = hWndFound;

      // Get the screen coordinates of the rectangle of the found window.
      RECTEX rect = ::GetWindowRect(m_hWndFound); // Rectangle area of the found window.
      //m_HintWin.MoveWindow(rect.left, rect.top, 300, 100, TRUE);
      m_HintWin.SetWindowPos(NULL, &rect, SWP_NOZORDER | SWP_NOSIZE);

      // We now highlight the found window.
      HighlightFoundWindow();

      // Display some information on this found window.
      DisplayInfoOnFoundWindow();
   }
}

void CMainDlg::OnStopFinder(bool bFromUser) {
   SetWindowText(::LoadStringResource(IDS_MAINFRAME)); // restore title

   SetCursor(CCursor().LoadSysCursor(IDC_ARROW));

   // If there was a found window, refresh it so that its highlighting is erased. 
   RefreshFoundWindow();

   // Set the bitmap on the Finder Tool icon to be the bitmap with the bullseye bitmap.
   m_statIcoFinder.SetIcon(m_Icon);
   m_statIcoFinder.SetWindowPos(NULL, &RECTEX(0,0,ICO_DEF_SIZE,ICO_DEF_SIZE), SWP_NOZORDER | SWP_NOMOVE);

   // Very important : must release the mouse capture.
   ReleaseCapture();

   // Make the main window appear normally.
   SetWindowPos(HWND_TOP, &RECTEX(), SWP_NOMOVE | SWP_NOSIZE);
   m_HintWin.ShowWindow(SW_HIDE);

   // Set the global search window flag to FALSE.
   m_bStartSearchWindow = FALSE;

   //if (::IsWindow(m_hWndFound))
   //   alert(::GetWindowText(m_hWndFound));

   m_hWndFound = NULL;

   if (bFromUser) {
      m_cbxErrCode.SetWindowText(NULL);
      CHintWin::ResultErrorCodes result = m_HintWin.GetResult();

      while (CB_ERR != m_cbxErrCode.DeleteString(0)) {} // clean

      for (CHintWin::ResultErrorCodes::const_iterator i=result.begin(); i != result.end(); i++)
         m_cbxErrCode.AddString(*i);
      if (result.size() > 0)
         m_cbxErrCode.SetCurSel(0); // ...    CBN_xxx,    OnEditChangeErrCode
      PostMessage(WM_COMMAND, MAKEWPARAM(IDC_CBX_ERRCODE, CBN_EDITCHANGE), (LPARAM)m_hWnd); // async call OnEditChangeErrCode
   }
}

BOOL CMainDlg::CheckWindowValidity(HWND hWndToCheck)
{
   if (hWndToCheck == NULL)
      return FALSE;

   // It must also be a valid window as far as the OS is concerned.
   if (::IsWindow(hWndToCheck) == FALSE)
      return FALSE;

   // Ensure that the window is not the current one which has already been found.
   if (hWndToCheck == m_hWndFound)
      return FALSE;

   // It must also not be the main_window/dialog_box itself.
   if (hWndToCheck == m_hWnd)
      return FALSE;

   // It also must not be one of the dialog box's children...
   HWND hWndTemp = ::GetParent(hWndToCheck);
   if (hWndTemp == m_hWnd)
      return FALSE;

   return TRUE;
}

void CMainDlg::RefreshFoundWindow() {
   if (!m_hWndFound)
      return;
   ::InvalidateRect(m_hWndFound, NULL, TRUE);
   ::UpdateWindow(m_hWndFound);
   ::RedrawWindow(m_hWndFound, NULL, NULL, RDW_FRAME | RDW_INVALIDATE | RDW_UPDATENOW | RDW_ALLCHILDREN);
}

void CMainDlg::HighlightFoundWindow() {
   HDC hWinDC = ::GetWindowDC(m_hWndFound); _ASSERT(!!hWinDC);
   if (hWinDC) {
      HGDIOBJ hPrevPen = ::SelectObject(hWinDC, m_RectanglePen); _ASSERT(!!hPrevPen);
      HGDIOBJ hPrevBrush = ::SelectObject(hWinDC, ::GetStockObject(HOLLOW_BRUSH)); _ASSERT(!!hPrevBrush);

      // Draw a rectangle in the DC covering the entire window area of the found window.
      RECTEX rect = ::GetWindowRect(m_hWndFound);
      BOOL bRes = ::Rectangle(hWinDC, 0, 0, rect.width(), rect.height()); _ASSERT(bRes);

      // restore
      ::SelectObject(hWinDC, hPrevPen);
      ::SelectObject(hWinDC, hPrevBrush);

      int iRes = ::ReleaseDC(m_hWndFound, hWinDC); _ASSERT(!!iRes);
   }
}

void CMainDlg::DisplayInfoOnFoundWindow() {
   m_HintWin.SetDescription(::Format(_T("Class - %s\r\nStyle - %s\r\nStyleEx - %s"),
      (LPCTSTR)::GetClassName(m_hWndFound),
      (LPCTSTR)nsHelper::WindowStyle(m_hWndFound),
      (LPCTSTR)nsHelper::WindowStyleEx(m_hWndFound)));
   m_HintWin.SetWindowText(::GetWindowText(m_hWndFound, 1024)); // 
}


BOOL CMainDlg::OnSetCursor(CWindow wnd, UINT nHitTest, UINT message) {
   SetMsgHandled(FALSE); 
   if (HTCLIENT != nHitTest)
      return FALSE;

   //OutputDebugString(::Format(_T("   CMainDlg::OnSetCursor: wnd=0x%08X, nHitTest=%i, message=0x%08X \r\n"), wnd.m_hWnd, nHitTest, message));
   if (wnd.m_hWnd == m_edtDscr.m_hWnd) {
      switch (message) {
      case WM_LBUTTONDBLCLK: //     ...
         //OnDblClickDescr();
         break;
      case WM_LBUTTONDOWN:
         DWORD dwTick = ::GetTickCount();
         DWORD dwDblClk = ::GetDoubleClickTime();
         if ((dwDblClk > m_dwLastClickOnEditBoxDescr-m_dwLastLastClickOnEditBoxDescr) &&
             (dwDblClk > dwTick-m_dwLastClickOnEditBoxDescr))
         {
            OnTripleClickDescr();
            m_dwLastLastClickOnEditBoxDescr = m_dwLastClickOnEditBoxDescr = 0;
         } else {
            m_dwLastLastClickOnEditBoxDescr = m_dwLastClickOnEditBoxDescr;
            m_dwLastClickOnEditBoxDescr = dwTick;
         }
         break;
      }
   } else
   if (wnd.m_hWnd == GetDlgItem(IDC_STATIC_DESCR)) {
      switch (message) {
      case WM_LBUTTONDOWN:
      case WM_RBUTTONDOWN:
         OnStaticDescrBttnDownClick();
         break;
      //case WM_RBUTTONUP: break;
      }
   }
   return FALSE;
}

void CMainDlg::OnTripleClickDescr() {
   //::OutputDebugString(_T("   CMainDlg::OnTripleClickDescr \r\n"));
   m_bErrCodeDescrSysMsg = !m_bErrCodeDescrSysMsg;
   PostMessage(WM_COMMAND, MAKEWPARAM(IDC_CBX_ERRCODE, CBN_EDITCHANGE), (LPARAM)m_hWnd); // async call OnEditChangeErrCode
}

void CMainDlg::OnStaticDescrBttnDownClick() {
   //::OutputDebugString(_T("   CMainDlg::OnStaticDescrBttnDownClick \r\n"));
   m_dwLanguageId = (m_dwLanguageId == LANG1) ? LANG2 : LANG1;
   PostMessage(WM_COMMAND, MAKEWPARAM(IDC_CBX_ERRCODE, CBN_EDITCHANGE), (LPARAM)m_hWnd); // async call OnEditChangeErrCode
}