////////////////////////////////////////////////////////////////////////////////
// File name: CommonLib.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: SeregaLBN@gmail.com
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru/CommonLib.html
// Date: 2010 12 06
//
// Description:   
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h" //     MFC /  Precompiled Headers

//#include <time.h>
#include <Math.h>
#include "CommonLib.h"
#include <AtlConv.h>
#include <Wincrypt.h>

#include <WinSock.h>
#pragma comment(lib, "ws2_32")

//#include <CommDlg.h>
//#pragma comment(lib, "ComDlg32")

#include <CDErr.h> // Common dialog error return codes

#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   //#include <ObjBase.h> // CoInitializeEx
   //#pragma comment(lib, "ole32")
#endif // DCOM

//#include <WinVer.h>
#pragma comment(lib, "Version")

namespace nsWinInet_API {
   #include <WinInet.h>
}
#pragma comment(lib, "WinInet")

#include <IpHlpApi.h>
#pragma comment(lib, "IpHlpApi")

#ifdef __AFX_H__
   #ifdef _DEBUG
      #undef THIS_FILE
      static char THIS_FILE[]=__FILE__;
      #define new DEBUG_NEW
   #endif
#endif


/*
  Name  : CRC-32
  Poly  : 0x04C11DB7       x^32 + x^26 + x^23 + x^22 + x^16 + x^12 + x^11 
                       + x^10 + x^8 + x^7 + x^5 + x^4 + x^2 + x + 1
  Init  : 0xFFFFFFFF
  Revert: true
  XorOut: 0xFFFFFFFF
  Check : 0xCBF43926 ("123456789")
  MaxLen: 268 435 455  (2 147 483 647 ) - 
   , ,     
     http://ru.wikipedia.org/wiki/CRC32
*/
UINT32 Crc32(IN const BYTE* buf, IN DWORD len) {
   UINT32 crc_table[256];
   UINT32 crc;

   for (UINT32 i = 0; i < 256; i++) {
      crc = i;
      for (int j = 0; j < 8; j++)
         crc = (crc & 1) ? ((crc >> 1) ^ 0xEDB88320UI32) : (crc >> 1);

      crc_table[i] = crc;
   };

   crc = 0xFFFFFFFFUI32;

   while (len--)
      crc = crc_table[(crc ^ *buf++) & 0xFF] ^ (crc >> 8);

   return crc ^ 0xFFFFFFFFUI32;
};

// see http://www.delphilab.ru/content/view/151/84/
BOOL Base64_Code(
   IN BYTE const *pData,  //    - ,   
   IN DWORD dwSize,
   OUT LPTSTR szCodeData, //   -  
   IN OUT DWORD &dwLenInChar // length in TCHAR (if szCodeData == NULL then return length include EOL)
) {
   if (!dwSize) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }
   DWORD dwNeedLen = ((((dwSize-1)/3)+1)<<2) + 1;
   if (szCodeData == NULL) {
      dwLenInChar = dwNeedLen;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return TRUE;
   }
   if (!pData) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }
   if (!szCodeData || (dwLenInChar < dwNeedLen)) {
      dwLenInChar = dwNeedLen;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return FALSE;
   }

   szCodeData[dwNeedLen-1] = 0; // EOL

   const static TCHAR base64ABC[] = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
   DWORD j = 0;
   DWORD i = 0;
   /** /
   //     2 .
   //       (   ) -
   //      .
   for (; i<dwSize; i+=3)
   {
      LONG l = (                    ((LONG)pData[i  ])<<16      ) |
               (((i+1) < dwSize) ? (((LONG)pData[i+1])<<8 ) : 0 ) |
               (((i+2) < dwSize) ? ( (LONG)pData[i+2]     ) : 0 );
                        szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
                        szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      if (i+1 < dwSize) szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
      if (i+2 < dwSize) szCodeData[j++] = base64ABC[(l    ) & 0x3F];
   }
   /**/
   for (; dwSize>2 && i<dwSize-2; i+=3) {
      LONG l = (((LONG)pData[i  ])<<16) |
               (((LONG)pData[i+1])<<8 ) |
                 (LONG)pData[i+2];
      szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
      szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
      szCodeData[j++] = base64ABC[(l    ) & 0x3F];
   }
   if (i<dwSize) {
      LONG l = (                    ((LONG)pData[i  ])<<16      ) |
               (((i+1) < dwSize) ? (((LONG)pData[i+1])<<8 ) : 0 );
                        szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
                        szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      if (i+1 < dwSize) szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
   }
   /**/
   switch (dwSize%3) {
   case 1: szCodeData[j++] = _T('=');
   case 2: szCodeData[j++] = _T('=');
   }
   dwLenInChar = j;

   ::SetLastError(NO_ERROR);
   return TRUE;
}

__forceinline int IndexB64(TCHAR c) {
   if ((c >= _T('A')) && (c <= _T('Z'))) return c-_T('A');
   if ((c >= _T('a')) && (c <= _T('z'))) return c-_T('a')+26;
   if ((c >= _T('0')) && (c <= _T('9'))) return c-_T('0')+52;
   if (c == _T('+')) return 62;
   if (c == _T('/')) return 63;
   return -1;
}

BOOL Base64_Decode(
   IN LPCTSTR szIn,  //    -  
   IN int iLenIn,    //   .  == -1,    ...
   OUT BYTE *pData,  //   -  
   IN OUT DWORD &dwSize // IN -  ; OUT -   
) {                     //  dwSize==0 -    
   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   if (iLenIn == -1) {
      iLenIn = lstrlen(szIn);
   }
   DWORD dwNeedSize = (iLenIn>>2)*3 -
                      (szIn[iLenIn-1]==_T('=') ? 1 : 0) -
                      (szIn[iLenIn-2]==_T('=') ? 1 : 0);

   if (pData == NULL) {
      dwSize = dwNeedSize;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return TRUE;
   }
   if (dwSize < dwNeedSize) {
      dwSize = dwNeedSize;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return FALSE;
   }
   if (iLenIn < 4) {
      //    - 4 
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   const static TCHAR base64ABC[] = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");

   dwSize = 0;
   int i=0;
   /** /
   //     2 .
   //       (   ) -
   //      .
   for (; i<iLenIn; i+=4) {
      bool in0=true , in1=false, in2=false, in3=false; //      
      bool bE0=false, bE1=false, bE2=false, bE3=false; //    "="
      int  iF0=0    , iF1=0    , iF2=0    , iF3=0    ; //     (,     Base64 )

      LONG l = ((in0 = (i+0) < iLenIn) && (bE0 = (szIn[i+0] != _T('='))) ? LONG(iF0 = IndexB64(szIn[i  ])) << 18 : 0) |
               ((in1 = (i+1) < iLenIn) && (bE1 = (szIn[i+1] != _T('='))) ? LONG(iF1 = IndexB64(szIn[i+1])) << 12 : 0) |
               ((in2 = (i+2) < iLenIn) && (bE2 = (szIn[i+2] != _T('='))) ? LONG(iF2 = IndexB64(szIn[i+2])) << 6  : 0) |
               ((in3 = (i+3) < iLenIn) && (bE3 = (szIn[i+3] != _T('='))) ? LONG(iF3 = IndexB64(szIn[i+3])) << 0  : 0);
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary...
      }

      if (in0 && bE0 && bE1) pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      if (in1 && bE1 && bE2) pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      if (in2 && bE2 && bE3) pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   /**/
   for (; i<iLenIn-5; i+=4) {
      int iF0=0, iF1=0, iF2=0, iF3=0; //     (,     Base64 )

      LONG l = (LONG(iF0 = IndexB64(szIn[i  ])) << 18) |
               (LONG(iF1 = IndexB64(szIn[i+1])) << 12) |
               (LONG(iF2 = IndexB64(szIn[i+2])) << 6 ) |
                LONG(iF3 = IndexB64(szIn[i+3]));
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary...
      }

      pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   {
      bool bE0=false, bE1=false, bE2=false, bE3=false; //    "="
      int  iF0=0    , iF1=0    , iF2=0    , iF3=0    ; //     (,     Base64 )

      LONG l = ((bE0 = (szIn[i+0] != _T('='))) ? LONG(iF0 = IndexB64(szIn[i  ])) << 18 : 0) |
               ((bE1 = (szIn[i+1] != _T('='))) ? LONG(iF1 = IndexB64(szIn[i+1])) << 12 : 0) |
               ((bE2 = (szIn[i+2] != _T('='))) ? LONG(iF2 = IndexB64(szIn[i+2])) << 6  : 0) |
               ((bE3 = (szIn[i+3] != _T('='))) ? LONG(iF3 = IndexB64(szIn[i+3])) << 0  : 0);
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary..
      }

      if (bE0 && bE1) pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      if (bE1 && bE2) pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      if (bE2 && bE3) pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   /**/
   ::SetLastError(NO_ERROR);
   return TRUE;
}

BOOL Base64_Code(
   IN BYTE const *pData,  //    - ,   
   IN DWORD dwSize,
   OUT CString &strOut //   -  
) {
   if (!dwSize || !pData) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   DWORD dwNeed = 0;
   BOOL bRes = Base64_Code(NULL, dwSize, NULL, dwNeed); //     (c EOL)
   DWORD dwErrCode = ::GetLastError();
   if (bRes) {
      TCHAR *szCodeData = new TCHAR[dwNeed];
      if (szCodeData == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         bRes = Base64_Code(pData, dwSize, szCodeData, dwNeed);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            strOut = szCodeData;
         }
         delete [] szCodeData; szCodeData = NULL;
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL Base64_Code(
   IN LPCTSTR szIn,    //    - ,   
   OUT CString &strOut //   -  
) {
   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   DWORD dwSizeInBytes = lstrlen(szIn) << (sizeof(TCHAR)-1);
   DWORD dwNeed = 0;
   BOOL bRes = Base64_Code(NULL, dwSizeInBytes, NULL, dwNeed); //     (c EOL)
   DWORD dwErrCode = ::GetLastError();
   if (bRes) {
      TCHAR *szCodeData = new TCHAR[dwNeed];
      if (szCodeData == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         bRes = Base64_Code((BYTE*)szIn, dwSizeInBytes, szCodeData, dwNeed);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            strOut = szCodeData;
         }
         delete [] szCodeData; szCodeData = NULL;
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL Base64_Decode(
   IN LPCTSTR szIn,     //    -  
   OUT CString &strOut  //   -  
) {
   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   DWORD dwSizeInChar = lstrlen(szIn);
   DWORD dwNeed = 0;
   BOOL bRes = Base64_Decode(szIn, dwSizeInChar, NULL, dwNeed);
   DWORD dwErrCode = ::GetLastError();
   if (bRes) {
      BYTE *pDecodeBuff = new BYTE[dwNeed];
      if (pDecodeBuff == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         ((TCHAR*)pDecodeBuff)[dwNeed-1] = 0;
         bRes = Base64_Decode(szIn, dwSizeInChar, pDecodeBuff, dwNeed);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            strOut = CString((TCHAR*)pDecodeBuff, dwNeed>>(sizeof(TCHAR)-1));
         }
         delete [] pDecodeBuff; pDecodeBuff = NULL;
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EncryptDES(IN const BYTE* pKey, IN DWORD dwSizeKey, IN const BYTE* pData, IN DWORD dwSizeData, IN DWORD dwCryptModeDES, OUT BYTE* pCryptData, IN OUT DWORD &dwSizeCryptData) {
   if (!(pKey && (dwSizeKey==8) && pData && dwSizeData && ((dwSizeData&7)==0) && pCryptData && dwSizeCryptData && (dwSizeData <= dwSizeCryptData))) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }

   DWORD dwErrCode = NO_ERROR;
   HCRYPTPROV hCryptProv = NULL;
   BOOL bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, 0);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      if (NTE_BAD_KEYSET == dwErrCode) {
         bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
         if (!bRes)
            dwErrCode = ::GetLastError();
      }
   }
   if (bRes) {
      BLOBHEADER keyHeader = {
         PLAINTEXTKEYBLOB,     // BYTE    bType;
         CUR_BLOB_VERSION,     // BYTE    bVersion;
         0,                    // WORD    reserved;
         CALG_DES              // ALG_ID  aiKeyAlg;
      };

      DWORD dwSizeBlob = sizeof(BLOBHEADER)+sizeof(DWORD)+dwSizeKey;
      BYTE *pBlob = new BYTE[dwSizeBlob];
      bRes = (NULL != pBlob);
      if (!bRes) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {

         //move keyHeader into buffer
         memcpy(pBlob, &keyHeader, sizeof(BLOBHEADER));
         //move keySize into buffer
         memcpy(pBlob+sizeof(BLOBHEADER), &dwSizeKey, sizeof(DWORD));
         //move key bytes into buffer
         memcpy(pBlob+sizeof(BLOBHEADER)+sizeof(DWORD), pKey, dwSizeKey);

         //Import key BLOB 
         HCRYPTKEY hKey = NULL;
         bRes = ::CryptImportKey(hCryptProv, pBlob,  dwSizeBlob,  0,  0, &hKey);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            //set DES mode
            bRes = ::CryptSetKeyParam(hKey, KP_MODE, (BYTE*)&dwCryptModeDES, 0);
            if (!bRes) {
               dwErrCode = ::GetLastError();
            } else {

               //set padding mode
             //DWORD padding = PKCS5_PADDING;// ZERO_PADDING; // http://msdn2.microsoft.com/en-us/library/aa380272.aspx !The only padding method currently defined is PKCS5_PADDING
             //bRes = ::CryptSetKeyParam(hKey, KP_PADDING, (BYTE*) &padding, 0);
             //if (!bRes) {
             //   dwErrCode = ::GetLastError();
             //} else {

             //   //set initialization vector
             //   BYTE *pIV = new BYTE[dwSizeData];
             //   bRes = (NULL != pIV);
             //   if (!bRes) {
             //      dwErrCode = ERROR_OUTOFMEMORY;
             //   } else {
             //      ZeroMemory(pIV, dwSizeData);

             //      bRes = ::CryptSetKeyParam(hKey, KP_IV, pIV, 0);
             //      if (!bRes) {
             //         dwErrCode = ::GetLastError();
             //      } else {

                        memcpy(pCryptData, pData, dwSizeData);
                        //Set FALSE to avoid padding
                        DWORD dwOutSize = dwSizeData;
                        bRes = ::CryptEncrypt(hKey, 0, FALSE, 0, pCryptData,
                           &dwOutSize,       // IN -    ; OUT -  
                           dwSizeCryptData); //   
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        } else {
                           dwSizeCryptData = dwOutSize;
                           // all Ok
                        }
             //      }
             //      delete [] pIV; pIV = NULL;
             //   }
             //}
            }

            BOOL bRes2 = ::CryptDestroyKey(hKey); hKey = NULL;
         }
         delete [] pBlob; pBlob = NULL;
      }
      BOOL bRes2 = ::CryptReleaseContext(hCryptProv, 0); hCryptProv = NULL;
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL DecryptDES(IN const BYTE* pKey, IN DWORD dwSizeKey, IN const BYTE* pCryptData, IN DWORD dwSizeCryptData, IN DWORD dwCryptModeDES, OUT BYTE* pDecryptData, IN OUT DWORD &dwSizeDecryptData) {
   if (!(pKey && (dwSizeKey==8) && pCryptData && dwSizeCryptData && ((dwSizeCryptData&7)==0) && pDecryptData && dwSizeDecryptData && (dwSizeCryptData <= dwSizeDecryptData))) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }

   DWORD dwErrCode = NO_ERROR;
   HCRYPTPROV hCryptProv = NULL;
   BOOL bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, 0);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      if (NTE_BAD_KEYSET == dwErrCode) {
         bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_DEF_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
         if (!bRes)
            dwErrCode = ::GetLastError();
      }
   }
   if (bRes) {
      BLOBHEADER keyHeader = {
         PLAINTEXTKEYBLOB,     // BYTE    bType;
         CUR_BLOB_VERSION,     // BYTE    bVersion;
         0,                    // WORD    reserved;
         CALG_DES              // ALG_ID  aiKeyAlg;
      };

      DWORD dwSizeBlob = sizeof(BLOBHEADER)+sizeof(DWORD)+dwSizeKey;
      BYTE *pBlob = new BYTE[dwSizeBlob];
      bRes = (NULL != pBlob);
      if (!bRes) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {

         //move keyHeader into buffer
         memcpy(pBlob, &keyHeader, sizeof(BLOBHEADER));
         //move keySize into buffer
         memcpy(pBlob+sizeof(BLOBHEADER), &dwSizeKey, sizeof(DWORD));
         //move key bytes into buffer
         memcpy(pBlob+sizeof(BLOBHEADER)+sizeof(DWORD), pKey, dwSizeKey);

         //Import key BLOB 
         HCRYPTKEY hKey = NULL;
         bRes = ::CryptImportKey(hCryptProv, pBlob,  dwSizeBlob,  0,  0, &hKey);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            //set DES mode
            bRes = ::CryptSetKeyParam(hKey, KP_MODE, (BYTE*)&dwCryptModeDES, 0);
            if (!bRes) {
               dwErrCode = ::GetLastError();
            } else {

               //set padding mode
             //DWORD padding = PKCS5_PADDING;// ZERO_PADDING; // http://msdn2.microsoft.com/en-us/library/aa380272.aspx !The only padding method currently defined is PKCS5_PADDING
             //bRes = ::CryptSetKeyParam(hKey, KP_PADDING, (BYTE*) &padding, 0);
             //if (!bRes) {
             //   dwErrCode = ::GetLastError();
             //} else {
             
             //   //set initialization vector
             //   BYTE *pIV = new BYTE[dwSizeCryptData];
             //   bRes = (NULL != pIV);
             //   if (!bRes) {
             //      dwErrCode = ERROR_OUTOFMEMORY;
             //   } else {
             //      ZeroMemory(pIV, dwSizeCryptData);
             
             //      bRes = ::CryptSetKeyParam(hKey, KP_IV, pIV, 0);
             //      if (!bRes) {
             //         dwErrCode = ::GetLastError();
             //      } else {

                        memcpy(pDecryptData, pCryptData, dwSizeCryptData);
                        //Set FALSE to avoid padding
                        DWORD dwSizeOut = dwSizeCryptData;
                        bRes = ::CryptDecrypt(hKey, 0, FALSE, 0, pDecryptData, &dwSizeOut);
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        } else {
                           dwSizeDecryptData = dwSizeOut;
                           // all Ok
                        }
             //      }
             //      delete [] pIV; pIV = NULL;
             //   }
             //}
            }

            BOOL bRes2 = ::CryptDestroyKey(hKey); hKey = NULL;
         }
         delete [] pBlob; pBlob = NULL;
      }
      BOOL bRes2 = ::CryptReleaseContext(hCryptProv, 0); hCryptProv = NULL;
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

// @TODO:   : http://www.rsdn.ru/forum/message/2927941.1.aspx
//  ...
BOOL Encrypt3DES(IN const BYTE* pKey, IN DWORD dwSizeKey, IN const BYTE* pData, IN DWORD dwSizeData, IN DWORD dwCryptModeDES, OUT BYTE* pCryptData, IN OUT DWORD &dwSizeCryptData) {
   if (!(pKey && (dwSizeKey==16) && pData && dwSizeData && ((dwSizeData&7)==0) && pCryptData && dwSizeCryptData && (dwSizeData <= dwSizeCryptData))) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }

   /** /
   //     DES...
   return
      EncryptDES(pKey+0, 8, pData     , dwSizeData     , dwCryptModeDES, pCryptData, dwSizeCryptData) &&
      DecryptDES(pKey+8, 8, pCryptData, dwSizeCryptData, dwCryptModeDES, pCryptData, dwSizeCryptData) &&
      EncryptDES(pKey+0, 8, pCryptData, dwSizeCryptData, dwCryptModeDES, pCryptData, dwSizeCryptData);
   //     ...
   /**/
   DWORD dwErrCode = NO_ERROR;
   HCRYPTPROV hCryptProv = NULL;
   BOOL bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, 0);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      if (NTE_BAD_KEYSET == dwErrCode) {
         bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
         if (!bRes)
            dwErrCode = ::GetLastError();
      }
   }
   if (bRes) {
      BLOBHEADER keyHeader = {
         PLAINTEXTKEYBLOB,     // BYTE    bType;
         CUR_BLOB_VERSION,     // BYTE    bVersion;
         0,                    // WORD    reserved;
         CALG_3DES_112         // ALG_ID  aiKeyAlg;
      };

      DWORD dwSizeBlob = sizeof(BLOBHEADER)+sizeof(DWORD)+dwSizeKey;
      BYTE *pBlob = new BYTE[dwSizeBlob];
      bRes = (NULL != pBlob);
      if (!bRes) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {

         //move keyHeader into buffer
         memcpy(pBlob, &keyHeader, sizeof(BLOBHEADER));
         //move keySize into buffer
         memcpy(pBlob+sizeof(BLOBHEADER), &dwSizeKey, sizeof(DWORD));
         *(DWORD*)(pBlob+sizeof(BLOBHEADER)) = dwSizeKey;
         //move key bytes into buffer
         memcpy(pBlob+sizeof(BLOBHEADER)+sizeof(DWORD), pKey, dwSizeKey);

         //Import key BLOB 
         HCRYPTKEY hKey = NULL;
         bRes = ::CryptImportKey(hCryptProv, pBlob,  dwSizeBlob,  0,  0, &hKey);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            //set DES mode
            bRes = ::CryptSetKeyParam(hKey, KP_MODE, (BYTE*)&dwCryptModeDES, 0);
            if (!bRes) {
               dwErrCode = ::GetLastError();
            } else {

               //set padding mode
             //DWORD padding = PKCS5_PADDING;// ZERO_PADDING; // http://msdn2.microsoft.com/en-us/library/aa380272.aspx !The only padding method currently defined is PKCS5_PADDING
             //bRes = ::CryptSetKeyParam(hKey, KP_PADDING, (BYTE*) &padding, 0);
             //if (!bRes) {
             //   dwErrCode = ::GetLastError();
             //} else {

             //   //set initialization vector
             //   BYTE *pIV = new BYTE[dwSizeData];
             //   bRes = (NULL != pIV);
             //   if (!bRes) {
             //      dwErrCode = ERROR_OUTOFMEMORY;
             //   } else {
             //      ZeroMemory(pIV, dwSizeData);

             //      bRes = ::CryptSetKeyParam(hKey, KP_IV, pIV, 0);
             //      if (!bRes) {
             //         dwErrCode = ::GetLastError();
             //      } else {

                        memcpy(pCryptData, pData, dwSizeData);
                        //Set FALSE to avoid padding 
                        DWORD dwOutSize = dwSizeData;
                        bRes = ::CryptEncrypt(hKey, 0, FALSE, 0, pCryptData,
                           &dwOutSize,       // IN -    ; OUT -  
                           dwSizeCryptData); //   
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        } else {
                           dwSizeCryptData = dwOutSize;
                           // all Ok
                        }
             //      }
             //      delete [] pIV; pIV = NULL;
             //   }
             //}
            }

            BOOL bRes2 = ::CryptDestroyKey(hKey); hKey = NULL;
         }
         delete [] pBlob; pBlob = NULL;
      }
      BOOL bRes2 = ::CryptReleaseContext(hCryptProv, 0); hCryptProv = NULL;
   }
   ::SetLastError(dwErrCode);
   return bRes;
   /**/
}

BOOL Decrypt3DES(IN const BYTE* pKey, IN DWORD dwSizeKey, IN const BYTE* pCryptData, IN DWORD dwSizeCryptData, IN DWORD dwCryptModeDES, OUT BYTE* pDecryptData, IN OUT DWORD &dwSizeDecryptData) {
   if (!(pKey && (dwSizeKey==16) && pCryptData && dwSizeCryptData && ((dwSizeCryptData&7)==0) && pDecryptData && dwSizeDecryptData && (dwSizeCryptData <= dwSizeDecryptData))) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }

   /** /
   //     DES...
   return
      DecryptDES(pKey+0, 8, pCryptData  , dwSizeCryptData  , dwCryptModeDES, pDecryptData, dwSizeDecryptData) &&
      EncryptDES(pKey+8, 8, pDecryptData, dwSizeDecryptData, dwCryptModeDES, pDecryptData, dwSizeDecryptData) &&
      DecryptDES(pKey+0, 8, pDecryptData, dwSizeDecryptData, dwCryptModeDES, pDecryptData, dwSizeDecryptData);
   //     ...
   /**/
   DWORD dwErrCode = NO_ERROR;
   HCRYPTPROV hCryptProv = NULL;
   BOOL bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, 0);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      if (NTE_BAD_KEYSET == dwErrCode) {
         bRes = ::CryptAcquireContext(&hCryptProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
         if (!bRes)
            dwErrCode = ::GetLastError();
      }
   }
   if (bRes) {
      BLOBHEADER keyHeader = {
         PLAINTEXTKEYBLOB,     // BYTE    bType;
         CUR_BLOB_VERSION,     // BYTE    bVersion;
         0,                    // WORD    reserved;
         CALG_3DES_112         // ALG_ID  aiKeyAlg;
      };

      DWORD dwSizeBlob = sizeof(BLOBHEADER)+sizeof(DWORD)+dwSizeKey;
      BYTE *pBlob = new BYTE[dwSizeBlob];
      bRes = (NULL != pBlob);
      if (!bRes) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {

         //move keyHeader into buffer
         memcpy(pBlob, &keyHeader, sizeof(BLOBHEADER));
         //move keySize into buffer
         memcpy(pBlob+sizeof(BLOBHEADER), &dwSizeKey, sizeof(DWORD));
         //move key bytes into buffer
         memcpy(pBlob+sizeof(BLOBHEADER)+sizeof(DWORD), pKey, dwSizeKey);

         //Import key BLOB 
         HCRYPTKEY hKey = NULL;
         bRes = ::CryptImportKey(hCryptProv, pBlob,  dwSizeBlob,  0,  0, &hKey);
         if (!bRes) {
            dwErrCode = ::GetLastError();
         } else {
            //set DES mode
            bRes = ::CryptSetKeyParam(hKey, KP_MODE, (BYTE*)&dwCryptModeDES, 0);
            if (!bRes) {
               dwErrCode = ::GetLastError();
            } else {

               //set padding mode
             //DWORD padding = PKCS5_PADDING;// ZERO_PADDING; // http://msdn2.microsoft.com/en-us/library/aa380272.aspx !The only padding method currently defined is PKCS5_PADDING
             //bRes = ::CryptSetKeyParam(hKey, KP_PADDING, (BYTE*) &padding, 0);
             //if (!bRes) {
             //   dwErrCode = ::GetLastError();
             //} else {
             
             //   //set initialization vector
             //   BYTE *pIV = new BYTE[dwSizeCryptData];
             //   bRes = (NULL != pIV);
             //   if (!bRes) {
             //      dwErrCode = ERROR_OUTOFMEMORY;
             //   } else {
             //      ZeroMemory(pIV, dwSizeCryptData);
             
             //      bRes = ::CryptSetKeyParam(hKey, KP_IV, pIV, 0);
             //      if (!bRes) {
             //         dwErrCode = ::GetLastError();
             //      } else {

                        memcpy(pDecryptData, pCryptData, dwSizeCryptData);
                        //Set FALSE to avoid padding 
                        DWORD dwSizeOut = dwSizeCryptData;
                        bRes = ::CryptDecrypt(hKey, 0, FALSE, 0, pDecryptData, &dwSizeOut);
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        } else {
                           dwSizeDecryptData = dwSizeOut;
                           // all Ok
                        }
             //      }
             //      delete [] pIV; pIV = NULL;
             //   }
             //}
            }

            BOOL bRes2 = ::CryptDestroyKey(hKey); hKey = NULL;
         }
         delete [] pBlob; pBlob = NULL;
      }
      BOOL bRes2 = ::CryptReleaseContext(hCryptProv, 0); hCryptProv = NULL;
   }
   ::SetLastError(dwErrCode);
   return bRes;
   /**/
}

CString SelectFile(BOOL bOpenDialog, HWND hWndOwner, LPCTSTR szDefSelectedFile, LPCTSTR szDefExt, LPCTSTR szFilter, LPCTSTR szTitle, LPCTSTR szInitialDir, DWORD dwFlags) {
   CString strFileName;
   DWORD nMaxFile = max(MAX_PATH, (szDefSelectedFile ? lstrlen(szDefSelectedFile)+1 : 0));
anew1:
   TCHAR *szFile = new TCHAR [nMaxFile];
anew2:
   if (szFile == NULL) {
      ::SetLastError(ERROR_OUTOFMEMORY);
   } else {
      szFile[0] = 0;
      if (szDefSelectedFile) {
         lstrcpyn(szFile, szDefSelectedFile, min(nMaxFile, (DWORD)lstrlen(szDefSelectedFile)+1));
      }
      OPENFILENAME OpenFileName = {
         sizeof(OPENFILENAME), // DWORD         lStructSize;
         hWndOwner           , // HWND          hwndOwner;
         NULL                , // HINSTANCE     hInstance;
         szFilter            , // LPCTSTR       lpstrFilter;
         NULL                , // LPTSTR        lpstrCustomFilter;
         0                   , // DWORD         nMaxCustFilter;
         0                   , // DWORD         nFilterIndex;
         szFile              , // LPTSTR        lpstrFile;
         nMaxFile            , // DWORD         nMaxFile;
         NULL                , // LPTSTR        lpstrFileTitle;
         0                   , // DWORD         nMaxFileTitle;
         szInitialDir        , // LPCTSTR       lpstrInitialDir;
         szTitle             , // LPCTSTR       lpstrTitle;
         dwFlags             , // DWORD         Flags;
         0                   , // WORD          nFileOffset;
         0                   , // WORD          nFileExtension;
         szDefExt            , // LPCTSTR       lpstrDefExt;
         0                   , // LPARAM        lCustData;
         NULL                , // LPOFNHOOKPROC lpfnHook;
         NULL                  // LPCTSTR       lpTemplateName;
      };
      if (bOpenDialog ? ::GetOpenFileName(&OpenFileName) : ::GetSaveFileName(&OpenFileName)) {
         strFileName = szFile;
      } else {
         DWORD dwError = ::CommDlgExtendedError();
         switch (dwError) {
         case FNERR_BUFFERTOOSMALL:
            {
             //nMaxFile = nMaxFile << 1;
               nMaxFile = *(short*)szFile;// first 2 bytes of the buffer pointed to by the lpstrFile member are set to an integer value specifying the size required to receive the full name.
               delete [] szFile; szFile = NULL;
               goto anew1;
            } break;
         case FNERR_INVALIDFILENAME:
            {
               szDefSelectedFile = NULL;
               goto anew2;
            } break;
         }
      }
      delete [] szFile; szFile = NULL;
   }
   return strFileName;
}

CString SelectFolder(
   HWND hWndOwner,   //    
   LPCTSTR szTitle,
   DWORD dwFlags,
   int nFolder)      //  -1 -      
                     //  CSIDL_... ( , see SHGetSpecialFolderLocation) -   
{
   CString strFolder;
   IMalloc *pMalloc = NULL;
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   HRESULT hRes = ::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
#endif // DCOM
   if (::SHGetMalloc(&pMalloc) == NOERROR) {
      ITEMIDLIST *pIIdL = NULL;
      TCHAR szFolder[MAX_PATH] = {0};
      if (nFolder == -1) {
         BROWSEINFO bi = {
            hWndOwner      , // HWND            hwndOwner;
            NULL           , // LPCITEMIDLIST   pidlRoot;
            szFolder       , // LPTSTR          pszDisplayName;
            szTitle        , // LPCTSTR         lpszTitle;
            dwFlags        , // UINT            ulFlags;
            NULL           , // BFFCALLBACK     lpfn;
            0              , // LPARAM          lParam;
            0                // int             iImage;
         };
         LPITEMIDLIST pIIdL = ::SHBrowseForFolder(&bi);
         if (pIIdL != NULL) {
            strFolder = szFolder; //   
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      } else {
         if (::SHGetSpecialFolderLocation(hWndOwner, nFolder, &pIIdL) == NOERROR) {
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      }
      if (pIIdL) {
         pMalloc->Free(pIIdL); pIIdL = NULL;
      }
      pMalloc->Release(); pMalloc = NULL;
   }
   return strFolder;
}

//  
ULONGLONG GetFileSizeEx(LPCTSTR szFileName) {
   ULONGLONG llSize = ULLONG_MAX; // INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         DWORD dwSizeHigh = 0;
         DWORD dwSizeLow  = ::GetFileSize(hFile, &dwSizeHigh);
         dwErrCode = ::GetLastError();
         if ((dwSizeLow == INVALID_FILE_SIZE) &&
             (dwErrCode != NO_ERROR))
         {
            // error!
         } else {
            dwErrCode = ERROR_SUCCESS;
            llSize = MAKELONGLONG(dwSizeLow, dwSizeHigh);
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return llSize;
}

//  
DWORD GetFileSize(LPCTSTR szFileName) {
   DWORD dwSize = INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         dwSize = ::GetFileSize(hFile, NULL);
         if (dwSize == INVALID_FILE_SIZE) {
            dwErrCode = ::GetLastError();
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return dwSize;
}

//         (     )
CString GetFileDir(LPCTSTR szFullFileName) {
   CString strRes;
   if (szFullFileName == NULL) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
   } else {
#ifndef __EXCLUDE_CRT__
      TCHAR szDrive[_MAX_DRIVE] = {0};
      TCHAR szDir  [_MAX_DIR  ] = {0};
      TCHAR szFName[_MAX_FNAME] = {0};
      TCHAR szExt  [_MAX_EXT  ] = {0};
   #ifdef _tsplitpath_s
      _tsplitpath_s(szFullFileName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFName, _MAX_FNAME, szExt, _MAX_EXT);
   #else
      _tsplitpath(szFullFileName, szDrive, szDir, szFName, szExt);
   #endif
      if (szDrive[0]) {
         strRes = szDrive;
         strRes += szDir[0] ? szDir : _T("\\");
      } else
#endif __EXCLUDE_CRT__
      {
         //  
         strRes = szFullFileName;
         int iFind = strRes.ReverseFind(_T('\\'));
         if (iFind != -1) {
            strRes = strRes.Left(iFind+1);
         } else {
            iFind = strRes.ReverseFind(_T('/'));
            if (iFind != -1) {
               strRes = strRes.Left(iFind+1);
            } else {
               if (!strRes.IsEmpty()) {
                  strRes += _T("\\");
               }
               //strRes.Empty();
               //::SetLastError(ERROR_INVALID_PARAMETER);
            }
         }
      }
   }
   return strRes;
}

BOOL ParseFileName(IN LPCTSTR szFullFileName, OUT CString &strDrive, OUT CString &strDir, OUT CString &strFileName, OUT CString &strExtension) {
   if (!szFullFileName || !szFullFileName[0]) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   strDrive.Empty(); strDir.Empty(); strFileName.Empty(); strExtension.Empty();

#ifndef __EXCLUDE_CRT__
   TCHAR szDrive[_MAX_DRIVE] = {0};
   TCHAR szDir  [_MAX_DIR  ] = {0};
   TCHAR szFName[_MAX_FNAME] = {0};
   TCHAR szExt  [_MAX_EXT  ] = {0};
   #ifdef _tsplitpath_s
      errno_t iRes = _tsplitpath_s(szFullFileName, szDrive, chDIMOF(szDrive), szDir, chDIMOF(szDir), szFName, chDIMOF(szFName), szExt, chDIMOF(szExt));
      if (iRes != 0) {
         ::SetLastError(E_FAIL); // ???
         return FALSE;
      }
   #else _tsplitpath_s
      _tsplitpath(szFullFileName, szDrive, szDir, szFName, szExt);
      if (szDrive[0]==0 && szDir[0]==0 && szFName[0]==0 && szExt[0] == 0) {
         ::SetLastError(E_FAIL); // ???
         return FALSE;
      }
   #endif _tsplitpath_s

   strDrive = szDrive; strDir = szDir; strFileName = szFName; strExtension = szExt;
   ::SetLastError(NO_ERROR);
   return TRUE;

#else __EXCLUDE_CRT__
   ::SetLastError(ERROR_CALL_NOT_IMPLEMENTED); // ???
   return FALSE;
#endif __EXCLUDE_CRT__
}

//      
CString GetFileName(LPCTSTR szFullFileName) {
   CString strRes;
   if (szFullFileName == NULL) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
   } else {
#ifndef __EXCLUDE_CRT__
      CString strDrive, strDir, strFileName, strExtension;
      BOOL bRes = ::ParseFileName(szFullFileName, strDrive, strDir, strFileName, strExtension);
      if (bRes) {
         strRes = strFileName + strExtension;
      } else
#endif __EXCLUDE_CRT__
      {
         //  
         strRes = szFullFileName;
         int iFind = strRes.ReverseFind(_T('\\'));
         if (iFind != -1) {
            strRes = strRes.Right(strRes.GetLength()-(iFind+1));
         } else {
            iFind = strRes.ReverseFind(_T('/'));
            if (iFind != -1) {
               strRes = strRes.Right(strRes.GetLength()-(iFind+1));
            } else {
               //strRes.Empty();
               //::SetLastError(ERROR_INVALID_PARAMETER);
            }
         }
      }
   }
   return strRes;
}

CString GetFileVersion(LPCTSTR szFileName, OUT WORD *pwVerMSHigh, OUT WORD *pwVerMSLow, OUT WORD *pwVerLSHigh, OUT WORD *pwVerLSLow) {
   CString strRes;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!FileExist(szFileName)) {
      dwErrCode = ::GetLastError();
   } else {
      DWORD dwSize = ::GetFileVersionInfoSize(szFileName, 0);
      if (dwSize == 0) {
         dwErrCode = ::GetLastError();
      } else {
         BYTE *pData = new BYTE [dwSize];
         if (pData == NULL) {
            dwErrCode = ERROR_OUTOFMEMORY;
         } else {
            BOOL bRes = ::GetFileVersionInfo(szFileName, 0, dwSize, pData);
            if (!bRes ) {
               dwErrCode = ::GetLastError();
            } else {
               VS_FIXEDFILEINFO *pFixeFileInfo = NULL;
               UINT uLen = 0;
               bRes = ::VerQueryValue(pData, _T("\\"), (void**)&pFixeFileInfo, &uLen);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               } else {
                  WORD v1 = HIWORD(pFixeFileInfo->dwFileVersionMS); if (pwVerMSHigh) { *pwVerMSHigh = v1; }
                  WORD v2 = LOWORD(pFixeFileInfo->dwFileVersionMS); if (pwVerMSLow ) { *pwVerMSLow  = v2; }
                  WORD v3 = HIWORD(pFixeFileInfo->dwFileVersionLS); if (pwVerLSHigh) { *pwVerLSHigh = v3; }
                  WORD v4 = LOWORD(pFixeFileInfo->dwFileVersionLS); if (pwVerLSLow ) { *pwVerLSLow  = v4; }
                  strRes.Format(_T("%i.%i.%i.%i"), int(v1),int(v2),int(v3),int(v4));
               }
            }
            delete [] pData; pData = NULL;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return strRes;
}

CString GetWindowText(HWND hWnd, int iMaxLen) {
   CString strCaption;
   DWORD dwErrCode = NO_ERROR;
   int iNeed = ::GetWindowTextLength(hWnd);
   if (iNeed) {
      if (iMaxLen > 0)
         iNeed = min(iNeed, iMaxLen);
      TCHAR *szCaption = new TCHAR[iNeed+1]; // + OEL
      int iRes = ::GetWindowText(hWnd, szCaption, iNeed+1);
      dwErrCode = ::GetLastError();
      _ASSERT_EXPR(iRes == iNeed, L"GetWindowText");
      strCaption = szCaption;
   }
   ::SetLastError(dwErrCode);
   return strCaption;
}

CString GetIPAdress() {
   CString strRes;

   // 1.    Internet Protocol Helper (IP Helper) API
   //    - GetAdaptersInfo
   ULONG ulOutBufLen = 0;
   DWORD dwErrCode = ::GetAdaptersInfo(NULL, &ulOutBufLen);
   if (dwErrCode == ERROR_BUFFER_OVERFLOW) {
      PIP_ADAPTER_INFO pInfo = (PIP_ADAPTER_INFO) new BYTE [ulOutBufLen];
      if (pInfo == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         dwErrCode = ::GetAdaptersInfo(pInfo, &ulOutBufLen);
         if (dwErrCode == ERROR_SUCCESS) {
            strRes = pInfo->IpAddressList.IpAddress.String;
         }
         delete [] pInfo; pInfo = NULL;
      }
   }

   // 2.    Windows Sockets 2 API
   //    - gethostname  gethostbyname
   if (strRes.IsEmpty()) {
      HOSTENT *he = NULL;
      BYTE *IP = NULL;
      char name[0xFF];

      if (0 != ::gethostname(name, sizeof(name))) {
         dwErrCode = ::WSAGetLastError();
      } else {
         he = ::gethostbyname(name);
         if (he == NULL) {
            dwErrCode = ::WSAGetLastError();
         } else {
            IP = (BYTE *)he->h_addr_list[0];
         }
         if (IP) {
            strRes.Format(_T("%i.%i.%i.%i"), int(IP[0]), int(IP[1]), int(IP[2]), int(IP[3]));
         }
      }
   }

   ::SetLastError(dwErrCode);
   return strRes;
}

CString GetHostName() {
   HOSTENT *he = NULL;
   BYTE *IP = NULL;
   char name[0xFF];

   gethostname(name, sizeof(name));
   he = gethostbyname(name);
   return CString(he ? he->h_name : NULL);
}

CString MemCopyAsHex(LPCVOID pData, DWORD dwSize, BOOL bUsePrefix, LPCTSTR szSeparator)
{
   /*
   //      
   CString strRes;
   for (DWORD i=0; i<dwSize; i++) {
      if (szSeparator && szSeparator[0]) {
         strRes += szSeparator;
      }
      strRes += ::Format(bUsePrefix ? _T("0x%02X") : _T("%02X"), int(((BYTE*)pData)[i]));
   }
   if (!strRes.IsEmpty() && szSeparator && szSeparator[0]) {
      strRes = strRes.Mid(lstrlen(szSeparator));
   }
   /**/
   if (!pData || !dwSize) return _T("");
   int iMaxCharIndex = (dwSize<<1) + (bUsePrefix ? (dwSize<<1) : 0) + ((szSeparator && szSeparator[0])?(lstrlen(szSeparator)*(dwSize-1)):0);
   CString strRes(_T('\0'), iMaxCharIndex+0);
   int j=0;
   for (size_t i=0; i<dwSize; i++) {
      if (bUsePrefix) {
         strRes.SetAt(j++, _T('0'));
         strRes.SetAt(j++, _T('x'));
      }

      BYTE bH = ((BYTE*)pData)[i] >> 4;
      BYTE bL = ((BYTE*)pData)[i] & 0x0F;

      TCHAR ch = (bH < 10) ? (_T('0')+bH) : (_T('A')+(bH-10));
      strRes.SetAt(j++, ch);

      ch = (bL < 10) ? (_T('0')+bL) : (_T('A')+(bL-10));
      strRes.SetAt(j++, ch);

      if ((i<dwSize-1) && szSeparator && szSeparator[0]) {
         for (int k=0; *(szSeparator+k); k++) {
            strRes.SetAt(j++, szSeparator[k]);
         }
      }
   }
   return strRes;
}

CHAR ToChar(WCHAR ch) {
   WCHAR wszData[2] = {ch, L'\0'};
   CHAR szData[2] = {'\0', '\0'};
   int iRes = ::WideCharToMultiByte(CP_ACP, 0, wszData, 1, szData, 2, NULL, NULL);
   return (iRes == 0) ? '?' : szData[0];
}

BOOL ToByte(TCHAR szInStr[2], OUT BYTE &res) {
   res = 0;
   for (int i=0; i<2; i++) {
      BYTE b = 0;
      TCHAR ch = szInStr[i];
      switch(ch) {
      case _T('0'):case _T('1'):case _T('2'):case _T('3'):case _T('4'):case _T('5'):case _T('6'):case _T('7'):case _T('8'):case _T('9'):
         b = ch-_T('0'); break;
      case _T('a'):case _T('b'):case _T('c'):case _T('d'):case _T('e'):case _T('f'):
         b = ch-_T('a')+10; break;
      case _T('A'):case _T('B'):case _T('C'):case _T('D'):case _T('E'):case _T('F'):
         b = ch-_T('A')+10; break;
      default:
         ::SetLastError(ERROR_INVALID_DATA);
         return FALSE;
      }
      if(i==0) res = b << 4;
      else res += b;
   }
   ::SetLastError(NO_ERROR);
   return TRUE;
}

CString MemCopyAsString(LPCVOID pData, DWORD dwSize, TCHAR chSeparatorEOL, BOOL bUnicode) {
   CString strRes;
   if (pData && dwSize) {
      //bUnicode = ::IsTextUnicode(pData, dwSize, NULL);
      if (bUnicode) {
         LPWSTR szBuff = (LPWSTR) new BYTE[dwSize+2+(dwSize&1)];
         if (szBuff) {
            memcpy(szBuff, pData, dwSize);
            memset(LPBYTE(szBuff)+dwSize, 0, 2+(dwSize&1));
            for (DWORD i=0; i<((dwSize+(dwSize&1))>>1); i++) {
               if (szBuff[i] == L'\0') {
                  szBuff[i] = chSeparatorEOL;
               }
            }
            strRes = szBuff;
            delete [] szBuff; szBuff = NULL;
         }
      } else {
         LPSTR szBuff = (LPSTR) new BYTE[dwSize+1];
         if (szBuff) {
            memcpy(szBuff, pData, dwSize);
            szBuff[dwSize] = 0; // EOL
            for (DWORD i=0; i<dwSize; i++) {
               if (szBuff[i] == '\0') {
               #ifdef UNICODE
                  szBuff[i] = ToChar(chSeparatorEOL);
               #else
                  szBuff[i] = chSeparatorEOL;
               #endif
               }
            }
            strRes = szBuff;
            delete [] szBuff; szBuff = NULL;
         }
      }
   }
   return strRes;
}

BOOL StringAsBytes(IN const CString &str, OUT BYTE *pBuffer, IN OUT DWORD &dwSize) {
   //    ,      !
   BOOL bRes = !str.IsEmpty();
   DWORD dwErrCode = NO_ERROR;
   if (!bRes) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      int iLen = str.GetLength();
      bRes = (dwSize >= (DWORD)((iLen>>1)+(iLen & 0x01)));
      if (!bRes) {
         dwErrCode = ERROR_INSUFFICIENT_BUFFER;
         dwSize = (iLen>>1)+(iLen & 0x01); // need
      } else {
         bRes = !!pBuffer;
         if (!bRes) {
            dwErrCode = ERROR_INVALID_PARAMETER;
         } else {
            for (int i=0; bRes && (i<iLen); i+=2) {
               TCHAR ch[2] = {str[i], ((i+1)<iLen) ? str[i+1] : _T('0')};
               BYTE b = 0;
               bRes = ToByte(ch, b);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               } else {
                  pBuffer[i>>1] = b;
               }
            }
            if (bRes)
               dwSize = (iLen>>1)+(iLen & 0x01);
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

HRESULT MemBufferToSafeArray(IN const BYTE *pData, IN DWORD dwSize, OUT SAFEARRAY *&sarrData) { // SafeArrayCreate
   if (!pData || !dwSize)
      return E_INVALIDARG;

   _ASSERT_EXPR(NULL==sarrData, L"MemBufferToSafeArray:  sarrData  ...      .");

#if (_MSC_VER >= 1400)
   sarrData = ::SafeArrayCreate(VT_UI1, 1, &SafeArrayBound(dwSize, 0));                      _ASSERT_EXPR(sarrData, L"MemBufferToSafeArray: SafeArrayCreate");
#else
   {
      SAFEARRAYBOUND r = SafeArrayBound(dwSize, 0);
      sarrData = ::SafeArrayCreate(VT_UI1, 1, &r);                                           _ASSERT_EXPR(sarrData, L"MemBufferToSafeArray: SafeArrayCreate");
   }
#endif
   if (!sarrData)
      return E_OUTOFMEMORY;

   BYTE *pSAData = NULL;
   HRESULT hRes = ::SafeArrayAccessData(sarrData, reinterpret_cast<void**>(&pSAData));       _ASSERT_EXPR(SUCCEEDED(hRes), L"MemBufferToSafeArray: SafeArrayAccessData");
   if (SUCCEEDED(hRes)) {
   #if (_MSC_VER >= 1400)
      errno_t err = memcpy_s(pSAData, dwSize, pData, dwSize);                                _ASSERT_EXPR(0==err, L"MemBufferToSafeArray: memcpy_s");
      if (err)
         hRes = E_FAIL;
      if (SUCCEEDED(hRes)) {
         hRes          = ::SafeArrayUnaccessData(sarrData);                                  _ASSERT_EXPR(SUCCEEDED(hRes ), L"MemBufferToSafeArray: SafeArrayUnaccessData");
      } else {
         HRESULT hRes2 = ::SafeArrayUnaccessData(sarrData);                                  _ASSERT_EXPR(SUCCEEDED(hRes2), L"MemBufferToSafeArray: SafeArrayUnaccessData");
      }
   #else
      memcpy(pSAData, pData, dwSize);
   #endif
   }
   return hRes;
}

HRESULT SafeArrayToMemBuffer(IN SAFEARRAY *pSarrData, OUT BYTE *&pData, IN OUT DWORD &dwSize) {
   HRESULT hRes = E_INVALIDARG;
   if (pSarrData) {
      ULONG ulNeedSize = ::GetArrSize(*pSarrData);
      if (!ulNeedSize)
         return E_INVALIDARG;

      if (dwSize < ulNeedSize) { //   
         dwSize = ulNeedSize;
         return DISP_E_BUFFERTOOSMALL;
      }

      if (!pData)
         return E_INVALIDARG;

      BYTE *pSAData = NULL;
      hRes = ::SafeArrayAccessData(pSarrData, reinterpret_cast<void**>(&pSAData));  _ASSERT_EXPR(SUCCEEDED(hRes), L"SafeArrayToMemBuffer: SafeArrayAccessData");
      if (SUCCEEDED(hRes)) {
      #if (_MSC_VER >= 1400)
         errno_t err = memcpy_s(pData, dwSize, pSAData, ulNeedSize);                _ASSERT_EXPR(0==err, L"SafeArrayToMemBuffer: memcpy_s");
         if (err)
            hRes = E_FAIL;
         else
            dwSize = ulNeedSize;
         if (SUCCEEDED(hRes)) {
            hRes          = ::SafeArrayUnaccessData(pSarrData);                     _ASSERT_EXPR(SUCCEEDED(hRes ), L"SafeArrayToMemBuffer: SafeArrayUnaccessData");
         } else {
            HRESULT hRes2 = ::SafeArrayUnaccessData(pSarrData);                     _ASSERT_EXPR(SUCCEEDED(hRes2), L"SafeArrayToMemBuffer: SafeArrayUnaccessData");
         }
      #else
         memcpy(pData, pSAData, ulNeedSize);
      #endif
      }
   }
   return hRes;
}

CString SafeArrayAsString(IN SAFEARRAY *pSarrData, TCHAR chSeparatorEOL, BOOL bUnicode, OUT HRESULT *phRes) {
   CString strRes;
   HRESULT hRes = E_INVALIDARG;
   if (pSarrData) {
      BYTE *pSAData = NULL;
      hRes = ::SafeArrayAccessData(pSarrData, reinterpret_cast<void**>(&pSAData));  _ASSERT_EXPR(SUCCEEDED(hRes), L"SafeArrayAsString: SafeArrayAccessData");
      if (SUCCEEDED(hRes)) {
         strRes = ::MemCopyAsString(pSAData, ::GetArrSize(*pSarrData), chSeparatorEOL, bUnicode);
         hRes = ::SafeArrayUnaccessData(pSarrData);                                 _ASSERT_EXPR(SUCCEEDED(hRes ), L"SafeArrayAsString: SafeArrayUnaccessData");
      }
      if (phRes)
         *phRes = hRes;
   }
   ::SetLastError(hRes);
   return strRes;
}

std::vector<CString> Split(IN const CString &str, IN LPCTSTR szSeparator, IN LPCTSTR szTrim) {
   std::vector<CString> result;

   CString qqq(str);
   int iF = -1;
   do {
      iF = qqq.Find(szSeparator);
      CString sub = (-1 == iF) ? qqq : qqq.Left(iF);
#ifndef _WTL_USE_CSTRING
      result.push_back(szTrim ? sub.Trim(szTrim): sub);
#else
      if (szTrim) {
         _ASSERT_EXPR(FALSE, L"!");
         result.push_back(sub.TrimRight(szTrim).TrimLeft(szTrim));
      }
#endif
      if (-1 != iF)
         qqq = qqq.Mid(iF+lstrlen(szSeparator));
   } while(iF != -1);

   return result;
}

BOOL SerializeRead(IN HANDLE hFile, OUT CString &str, UINT iMaxLength) {
   UINT iLen = 0;
   DWORD dwNOBR = 0;
   BOOL bRes = ::ReadFile(hFile, &iLen, sizeof(iLen), &dwNOBR, NULL) && (sizeof(iLen) == dwNOBR);
   if (bRes) {
      if (iLen == 0) {
         str.Empty();
      } else {
         if (iLen > iMaxLength) {
            bRes = FALSE;
            _ASSERT_EXPR(bRes, L" .\r\n\r\n- SerializeRead.\r\n      .");
         } else {
            BOOL bUnicode;
            bRes = ::ReadFile(hFile, &bUnicode, sizeof(bUnicode), &dwNOBR, NULL) && (sizeof(bUnicode) == dwNOBR);
            if (bRes) {
               UINT iSizeChar = bUnicode ? sizeof(WCHAR) : sizeof(CHAR);
               UINT iSizeBuff = (iLen+1)<<(bUnicode ? 1 : 0); // in bytes (+1 - EOL char)
               BYTE *szBuff = new BYTE[iSizeBuff];
               bRes = !!szBuff;
               if (bRes) {
                  szBuff[iSizeBuff-1] = 0; // EOL
                  if (bUnicode) {
                     szBuff[iSizeBuff-2] = 0; // EOL
                  }
                  bRes = ::ReadFile(hFile, szBuff, iSizeBuff-iSizeChar, &dwNOBR, NULL) && (iSizeBuff-iSizeChar == dwNOBR);
                  if (bRes) {
                     if (bUnicode) {
                        str = (LPCWSTR)szBuff;
                     } else {
                        str = (LPCSTR)szBuff;
                     }
                  }
                  delete [] szBuff; szBuff = NULL;
               }
            }
         }
      }
   }
   return bRes;
}

BOOL SerializeWrite(IN HANDLE hFile, IN const CString &str) {
   int iLen = str.GetLength();
   DWORD dwNOBW = 0;
   BOOL bRes = ::WriteFile(hFile, &iLen, sizeof(iLen), &dwNOBW, NULL) && (sizeof(iLen) == dwNOBW);
   if (bRes && iLen) {
#ifdef _UNICODE
      BOOL bUnicode = TRUE;
#else
      BOOL bUnicode = FALSE;
#endif
      bRes = (::WriteFile(hFile,    &bUnicode,              sizeof(bUnicode) , &dwNOBW, NULL) &&              (sizeof(bUnicode ) == dwNOBW)) &&
             (::WriteFile(hFile, (LPCTSTR)str, DWORD(iLen<<(sizeof(TCHAR)-1)), &dwNOBW, NULL) && (DWORD(iLen<<(sizeof(TCHAR)-1)) == dwNOBW));
   }
   return bRes;
}

void BeepSpeaker(DWORD dwFreq, DWORD dwDuration)
{
#ifdef _WIN64
   ::Beep(dwFreq, dwDuration);
#else // _WIN64
   dwFreq = min(max(0x25, dwFreq), 0x7FFF);
   static OSVERSIONINFO OsVersion = {
      sizeof(OSVERSIONINFO), // DWORD dwOSVersionInfoSize;
      0,                     // DWORD dwMajorVersion;
      0,                     // DWORD dwMinorVersion;
      0,                     // DWORD dwBuildNumber;
      0,                     // DWORD dwPlatformId;
      {_T('\0'),}            // TCHAR szCSDVersion[128];
   };
   static BOOL bRes = ::GetVersionEx(&OsVersion);

   /* We need to check if we're running on NT, because NT
   does not allow the "out" assembler command for security
   reasons and the Beep API function works via the speaker on NT,
   so that's ok.
   On Windows 9x Beep will sound the default system
   beep which is in most cases through the soundblaster.
   (frequency is not supported under Windows 9x) */

   if (OsVersion.dwPlatformId == VER_PLATFORM_WIN32_NT) {
      ::Beep(dwFreq, dwDuration);
   } else { //VER_PLATFORM_WIN32_WINDOWS
      __asm
      {
         mov al, -1
         out 61h, al
      }
      Sleep(dwDuration);
      __asm
      {
         mov al, 0
         out 61h, al
      }
   }
#endif // _WIN64
}

////////////////////////////////////////////////////////////////////////////////
//    begin class CRegistry
////////////////////////////////////////////////////////////////////////////////

#define BEGIN_REG_PARSE_PATH_EX(szPath, bPathWithValueName, bValidParam, bCreatePatch, regAccess) \
   DWORD dwErrCode = ERROR_SUCCESS; \
   if (!(szPath && szPath[0] && (bValidParam))) { \
      dwErrCode = ERROR_INVALID_PARAMETER; \
   } else { \
      LPTSTR szPath2 = _tcsdup(szPath); \
      if (szPath2 == NULL) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         LPTSTR szHKey = szPath2, szSubKey = NULL, szValueName = NULL; \
         TCHAR *szPos1 = _tcschr(szPath2, _T('\\')); \
         if (szPos1) { \
            szPos1[0] = 0; \
            if (bPathWithValueName) { \
               TCHAR *szPos2 = _tcsrchr(szPos1+1, _T('\\')); \
               if (szPos2) { \
                  szPos2[0] = 0; \
                  szSubKey = szPos1+1; \
                  szValueName = szPos2+1; \
               } else { \
                  szValueName = szPos1+1; \
               } \
            } else { \
               szSubKey = szPos1+1; \
            } \
         } \
         HKEY hKey = NULL; \
         if (lstrcmpi(szHKey, _T("HKEY_CLASSES_ROOT"       )) == 0) hKey = HKEY_CLASSES_ROOT       ; else \
         if (lstrcmpi(szHKey, _T("HKEY_CURRENT_USER"       )) == 0) hKey = HKEY_CURRENT_USER       ; else \
         if (lstrcmpi(szHKey, _T("HKEY_LOCAL_MACHINE"      )) == 0) hKey = HKEY_LOCAL_MACHINE      ; else \
         if (lstrcmpi(szHKey, _T("HKEY_USERS"              )) == 0) hKey = HKEY_USERS              ; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_DATA"   )) == 0) hKey = HKEY_PERFORMANCE_DATA   ; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_NLSTEXT")) == 0) hKey = HKEY_PERFORMANCE_NLSTEXT; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_TEXT"   )) == 0) hKey = HKEY_PERFORMANCE_TEXT   ; else \
         if (lstrcmpi(szHKey, _T("HKEY_CURRENT_CONFIG"     )) == 0) hKey = HKEY_CURRENT_CONFIG     ; else \
         if (lstrcmpi(szHKey, _T("HKEY_DYN_DATA"           )) == 0) hKey = HKEY_DYN_DATA           ; else { \
            dwErrCode = ERROR_BAD_PATHNAME; /* ERROR_PATH_NOT_FOUND */ \
         } \
         if (hKey) { \
            if (szSubKey && szSubKey[0]) { \
               if (bCreatePatch) { \
                  dwErrCode = ::RegCreateKey(hKey, szSubKey, &hKey); \
               } else { \
                  dwErrCode = ::RegOpenKeyEx(hKey, szSubKey, 0, KEY_READ | regAccess, &hKey); \
               } \
            } \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_PARSE_PATH \
               dwErrCode = ::GetLastError(); \
               if (szSubKey && szSubKey[0]) { \
                  ::RegCloseKey(hKey); hKey = NULL; \
               } \
            } \
         } \
         free(szPath2); \
      } \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_PARSE_PATH_GET(   bValidParam) BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE, bValidParam, FALSE, 0)
#define BEGIN_REG_PARSE_PATH_SET(   bValidParam) BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE, bValidParam,  TRUE, 0)
#define BEGIN_REG_PARSE_PATH_ENUM(  bValidParam) BEGIN_REG_PARSE_PATH_EX(szKey    , FALSE, bValidParam, FALSE, 0)
#define BEGIN_REG_PARSE_PATH_DELKEY(bValidParam) BEGIN_REG_PARSE_PATH_ENUM(bValidParam)
#define BEGIN_REG_PARSE_PATH_DELVAL              BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE,        TRUE, FALSE, KEY_SET_VALUE)
#define BEGIN_REG_PARSE_PATH_ExistKEY            BEGIN_REG_PARSE_PATH_EX(szKey    , FALSE, TRUE, FALSE, KEY_QUERY_VALUE)
#define BEGIN_REG_PARSE_PATH_ExistVAL            BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE, TRUE, FALSE, KEY_QUERY_VALUE)

#define BEGIN_REG_GET_DATA(needRegType) \
   DWORD cbMaxValue = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &cbMaxValue, NULL, NULL); \
   if (dwErrCode == ERROR_SUCCESS) { \
      BYTE *pbData = new BYTE[cbMaxValue]; \
      if (!pbData) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         DWORD dwType = REG_NONE, cbData=cbMaxValue; \
         dwErrCode = ::RegQueryValueEx(hKey, szValueName, NULL, &dwType, pbData, &cbData); \
         if (dwErrCode == ERROR_SUCCESS) { \
            if (dwType == needRegType) {

   #define END_REG_GET_DATA \
            } else { \
               dwErrCode = ERROR_DATATYPE_MISMATCH; \
            } \
         } \
      } \
      delete [] pbData; \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_ENUM_SUBKEY(bEnumAllSubKeys) \
   DWORD cSubKeys = 0, cchMaxSubKey = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, &cchMaxSubKey, NULL, NULL, NULL, NULL, NULL, NULL); \
   if ((dwErrCode == ERROR_SUCCESS) && (cSubKeys==0)) { \
      dwErrCode = ERROR_NO_MORE_ITEMS; \
   } \
   if ((dwErrCode == ERROR_SUCCESS) /*&& cSubKeys*/) { \
      TCHAR *szSubKey = new TCHAR[cchMaxSubKey+1]; \
      if (!szSubKey) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         for (dwIndex=(bEnumAllSubKeys?0:dwIndex); bEnumAllSubKeys ? (dwIndex<cSubKeys) : true; dwIndex++) { \
            BOOL bEnumAll = bEnumAllSubKeys; \
            DWORD cchSubKey = cchMaxSubKey+1; \
            PFILETIME pFileTime = NULL; \
            dwErrCode = ::RegEnumKeyEx(hKey, dwIndex, szSubKey, &cchSubKey, NULL, NULL, NULL, pFileTime); \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_ENUM_SUBKEY \
            } else { \
               break; \
            } \
            if (!bEnumAll) break; \
         } \
         delete [] szSubKey; \
      } \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_ENUM_VALUENAME(bEnumAllValueNames) \
   DWORD cValues = 0, cchMaxValueName = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, NULL, NULL, NULL, &cValues, &cchMaxValueName, NULL, NULL, NULL); \
   if ((dwErrCode == ERROR_SUCCESS) && (cValues==0)) { \
      dwErrCode = ERROR_NO_MORE_ITEMS; \
   } \
   if ((dwErrCode == ERROR_SUCCESS) /*&& cValues*/) { \
      TCHAR *szValueName = new TCHAR[cchMaxValueName+1]; \
      if (!szValueName) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         for (dwIndex=(bEnumAllValueNames?0:dwIndex); bEnumAllValueNames ? (dwIndex<cValues) : true; dwIndex++) { \
            BOOL bEnumAll = bEnumAllValueNames; \
            DWORD cchValueName = cchMaxValueName+1; \
            dwErrCode = ::RegEnumValue(hKey, dwIndex, szValueName, &cchValueName, NULL, &dwType, NULL, NULL); \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_ENUM_VALUENAME \
            } else { \
               break; \
            } \
            if (!bEnumAll) break; \
         } \
         delete [] szValueName; \
      } \
   } \
   ::SetLastError(dwErrCode)

//      
/* static */ CString CRegistry::GetString(IN HKEY hKey, IN LPCTSTR szValueName) {
   CString strResult;
   BEGIN_REG_GET_DATA(REG_SZ);
   strResult = (LPCTSTR)pbData;
   END_REG_GET_DATA;
   return strResult;
}

//      
/* static */ DWORD CRegistry::GetDWord(IN HKEY hKey, IN LPCTSTR szValueName) {
   DWORD dwResult = 0;
   BEGIN_REG_GET_DATA(REG_DWORD);
   dwResult = *((DWORD*)pbData);
   END_REG_GET_DATA;
   return dwResult;
}

//      
/* static */ DWORD CRegistry::GetBinary(IN HKEY hKey, IN LPCTSTR szValueName, OUT BYTE *pbValue, IN OUT DWORD &cbValue) {
   BEGIN_REG_GET_DATA(REG_BINARY);
   if (pbValue && (cbValue >= cbData)) {
      cbValue  = cbData;
      memcpy(pbValue, pbData, cbValue);
   } else {
      cbValue = cbData; //    
      dwErrCode = ERROR_INSUFFICIENT_BUFFER;
   }
   END_REG_GET_DATA;
   return dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetString(IN HKEY hKey, IN LPCTSTR szValueName, IN LPCTSTR szValue) {
   DWORD dwErrCode = ::RegSetValueEx(hKey, szValueName, 0, REG_SZ, (LPBYTE)szValue, (lstrlen(szValue)+1)<<(sizeof(TCHAR)-1));
   return ::SetLastError(dwErrCode), dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetDWord(IN HKEY hKey, IN LPCTSTR szValueName, IN DWORD dwValue) {
   DWORD dwErrCode = ::RegSetValueEx(hKey, szValueName, 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
   return ::SetLastError(dwErrCode), dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetBinary(IN HKEY hKey, IN LPCTSTR szValueName, IN const BYTE *pbValue, IN DWORD cbValue) {
   DWORD dwErrCode = (!pbValue || !cbValue) ? ERROR_INVALID_PARAMETER : ::RegSetValueEx(hKey, szValueName, 0, REG_BINARY, pbValue, cbValue);
   return ::SetLastError(dwErrCode), dwErrCode;
}

/* static */ CString CRegistry::GetString(IN LPCTSTR szKeyName) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_GET(TRUE);
   strResult = CRegistry::GetString(hKey, szValueName);
   END_REG_PARSE_PATH;
   return strResult;
}

/* static */ DWORD CRegistry::GetDWord(IN LPCTSTR szKeyName) {
   DWORD dwResult = 0;
   BEGIN_REG_PARSE_PATH_GET(TRUE);
   dwResult = CRegistry::GetDWord(hKey, szValueName);
   END_REG_PARSE_PATH;
   return dwResult;
}

/* static */ DWORD CRegistry::GetBinary(IN LPCTSTR szKeyName, OUT BYTE *pbValue, IN OUT DWORD &cbValue) {
   BEGIN_REG_PARSE_PATH_GET(pbValue && cbValue);
   dwErrCode = CRegistry::GetBinary(hKey, szValueName, pbValue, cbValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetString(IN LPCTSTR szKeyName, IN LPCTSTR szValue) {
   BEGIN_REG_PARSE_PATH_SET(!!szValue);
   dwErrCode = CRegistry::SetString(hKey, szValueName, szValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetDWord(IN LPCTSTR szKeyName, IN DWORD dwValue) {
   BEGIN_REG_PARSE_PATH_SET(TRUE);
   dwErrCode = CRegistry::SetDWord(hKey, szValueName, dwValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetBinary(IN LPCTSTR szKeyName, IN const BYTE *pbValue, IN DWORD cbValue) {
   BEGIN_REG_PARSE_PATH_SET(pbValue && cbValue);
   dwErrCode = CRegistry::SetBinary(hKey, szValueName, pbValue, cbValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

// find methods
namespace nsRegistry {
   BOOL EnumSubKeyName(IN HKEY hKey, IN LPCTSTR szKey, IN CRegistry::SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
      BOOL bRes = FALSE;
      DWORD dwIndex = 0;
      BEGIN_REG_ENUM_SUBKEY(true);
      bRes = lpEnumFunc(hKey, szKey, dwIndex, szSubKey, lpUserData);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         break;
      }
      END_REG_ENUM_SUBKEY;
      bRes = (dwErrCode == ERROR_SUCCESS) ||
             ((dwErrCode == ERROR_NO_MORE_ITEMS) && (cSubKeys == 0)); //  
      return bRes;
   }

   BOOL EnumValueName(IN HKEY hKey, IN LPCTSTR szKey, IN CRegistry::VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
      BOOL bRes = FALSE;
      DWORD dwIndex = 0;
      DWORD dwType = REG_NONE;
      BEGIN_REG_ENUM_VALUENAME(true);
      bRes = lpEnumFunc(hKey, szKey, dwIndex, szValueName, dwType, lpUserData);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         break;
      }
      END_REG_ENUM_VALUENAME;
      bRes = (dwErrCode == ERROR_SUCCESS) ||
             ((dwErrCode == ERROR_NO_MORE_ITEMS) && (cValues == 0)); //  
      return bRes;
   }
} // namespace nsRegistry

/* static */ CString CRegistry::EnumSubKeyName(IN HKEY hKey, IN DWORD dwIndex) {
   CString strResult;
   BEGIN_REG_ENUM_SUBKEY(false);
   strResult = szSubKey;
   END_REG_ENUM_SUBKEY;
   return strResult;
}

/* static */ CString CRegistry::EnumSubKeyName(IN LPCTSTR szKey, IN DWORD dwIndex) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_ENUM(TRUE);
   strResult = CRegistry::EnumSubKeyName(hKey, dwIndex);
   END_REG_PARSE_PATH;
   return strResult;
}

BOOL CRegistry::GetKeyPath(IN HKEY hKey, OUT CString &strKeyPath) {
   if (hKey == NULL) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }

   if (hKey == HKEY_CLASSES_ROOT       ) { strKeyPath = _T("HKEY_CLASSES_ROOT"       ); return TRUE; }
   if (hKey == HKEY_CURRENT_USER       ) { strKeyPath = _T("HKEY_CURRENT_USER"       ); return TRUE; }
   if (hKey == HKEY_LOCAL_MACHINE      ) { strKeyPath = _T("HKEY_LOCAL_MACHINE"      ); return TRUE; }
   if (hKey == HKEY_USERS              ) { strKeyPath = _T("HKEY_USERS"              ); return TRUE; }
   if (hKey == HKEY_PERFORMANCE_DATA   ) { strKeyPath = _T("HKEY_PERFORMANCE_DATA"   ); return TRUE; }
   if (hKey == HKEY_PERFORMANCE_NLSTEXT) { strKeyPath = _T("HKEY_PERFORMANCE_NLSTEXT"); return TRUE; }
   if (hKey == HKEY_PERFORMANCE_TEXT   ) { strKeyPath = _T("HKEY_PERFORMANCE_TEXT"   ); return TRUE; }
   if (hKey == HKEY_CURRENT_CONFIG     ) { strKeyPath = _T("HKEY_CURRENT_CONFIG"     ); return TRUE; }
   if (hKey == HKEY_DYN_DATA           ) { strKeyPath = _T("HKEY_DYN_DATA"           ); return TRUE; }

   BOOL bLoadLibrary = FALSE;
   HMODULE hMod = ::GetLibrary(_T("ntdll.dll"), TRUE, bLoadLibrary);
   _ASSERT_EXPR(hMod && !bLoadLibrary, L"...         'ntdll.dll'");
   if (!hMod)
      return FALSE;

   DWORD dwErrCode = NO_ERROR;
   BOOL bRes = FALSE;

   typedef DWORD (__stdcall *ZwQueryKeyType)(
      HANDLE  KeyHandle,
      int KeyInformationClass,
      PVOID  KeyInformation,
      ULONG  Length,
      PULONG  ResultLength);
   ZwQueryKeyType pZwQueryKeyType = reinterpret_cast<ZwQueryKeyType>(::GetProcAddress(hMod, "ZwQueryKey"));
   bRes = (pZwQueryKeyType != NULL);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   } else {
      DWORD dwSize = 0;
      dwErrCode = pZwQueryKeyType(hKey, 3, 0, 0, &dwSize);
      bRes = (/*STATUS_BUFFER_TOO_SMALL*/ 0xC0000023L == dwErrCode);
      if (bRes) {
         dwSize = dwSize + sizeof(WCHAR); // + EOL
         WCHAR* szBuf = new (std::nothrow) wchar_t[dwSize];
         bRes = (NULL != szBuf);
         if (!bRes) {
            dwErrCode = ERROR_OUTOFMEMORY;
         } else {
            dwErrCode = pZwQueryKeyType(hKey, 3, szBuf, dwSize, &dwSize);
            bRes = (/*STATUS_SUCCESS*/ NO_ERROR == dwErrCode);
            if (bRes) {
               szBuf[dwSize >> 1] = L'\0'; // set EOL
               strKeyPath = szBuf + sizeof(WCHAR);
            }

            delete [] szBuf; szBuf = NULL;
         }
      }
   }

   if (bLoadLibrary) {
      BOOL bRes2 = ::FreeLibrary(hMod);
      _ASSERT(bRes2);
   }

   ::SetLastError(dwErrCode);
   return bRes;
}

/* static */ BOOL CRegistry::EnumSubKeyName(IN HKEY hKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   CString strHKey;
   BOOL bHasKeyName = GetKeyPath(hKey, strHKey);
   return nsRegistry::EnumSubKeyName(hKey, !bHasKeyName ? NULL : (LPCTSTR)strHKey, lpEnumFunc, lpUserData);
}

/* static */ BOOL CRegistry::EnumSubKeyName(IN LPCTSTR szKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ENUM(!!lpEnumFunc);
   bRes = nsRegistry::EnumSubKeyName(hKey, szKey, lpEnumFunc, lpUserData);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ CString CRegistry::EnumValueName(IN HKEY hKey, IN DWORD dwIndex, OUT DWORD &dwType) {
   CString strResult;
   BEGIN_REG_ENUM_VALUENAME(false);
   strResult = szValueName;
   END_REG_ENUM_VALUENAME;
   return strResult;
}

/* static */ CString CRegistry::EnumValueName(IN LPCTSTR szKey, IN DWORD dwIndex, OUT DWORD &dwType) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_ENUM(TRUE);
   strResult = CRegistry::EnumValueName(hKey, dwIndex, dwType);
   END_REG_PARSE_PATH;
   return strResult;
}

/* static */ BOOL CRegistry::EnumValueName(IN HKEY hKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   CString strHKey;
   BOOL bHasKeyName = GetKeyPath(hKey, strHKey);
   return nsRegistry::EnumValueName(hKey, !bHasKeyName ? NULL : (LPCTSTR)strHKey, lpEnumFunc, lpUserData);
}

/* static */ BOOL CRegistry::EnumValueName(IN LPCTSTR szKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ENUM(!!lpEnumFunc);
   bRes = nsRegistry::EnumValueName(hKey, szKey, lpEnumFunc, lpUserData);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::DeleteKey(IN HKEY hKey, IN LPCTSTR szSubKey) {
   DWORD dwErrCode = ::RegDeleteKey(hKey, szSubKey);
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::DeleteKey(IN LPCTSTR szKey, IN LPCTSTR szSubKeyIn) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_DELKEY(!!szSubKeyIn);
   bRes = CRegistry::DeleteKey(hKey, szSubKeyIn);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::DeleteValue(IN HKEY hKey, IN LPCTSTR szValueName) {
   DWORD dwErrCode = ::RegDeleteValue(hKey, szValueName);
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::DeleteValue(IN LPCTSTR szKeyName) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_DELVAL;
   bRes = CRegistry::DeleteValue(hKey, szValueName);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::ExistKey(IN HKEY hKey) {
   DWORD cbMaxValue = 0;
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &cbMaxValue, NULL, NULL);
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::ExistKey(IN LPCTSTR szKey) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ExistKEY;
   bRes = CRegistry::ExistKey(hKey);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::ExistValue(IN HKEY hKey, IN LPCTSTR szValueName, OUT LPDWORD pdwRegType) {
   DWORD dwErrCode = ::RegQueryValueEx(hKey, szValueName, NULL, pdwRegType, NULL, NULL);
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::ExistValue(IN LPCTSTR szKeyName, OUT LPDWORD pdwRegType) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ExistVAL;
   bRes = CRegistry::ExistValue(hKey, szValueName, pdwRegType);
   END_REG_PARSE_PATH;
   return bRes;
}

////////////////////////////////////////////////////////////////////////////////
//    end class CRegistry
////////////////////////////////////////////////////////////////////////////////


BOOL String2GUID(IN LPCTSTR szGUID, OUT GUID &guid) {
   BOOL bRes = FALSE;
   DWORD dwErrCode = ERROR_INVALID_PARAMETER;
   if (szGUID) {
      USES_CONVERSION;
      HRESULT hRes = ::CLSIDFromString(T2OLE(const_cast<TCHAR*>(szGUID)), &guid);
      switch (hRes) {
      case NOERROR           : bRes = TRUE ; dwErrCode = ERROR_SUCCESS;    break;
      case CO_E_CLASSSTRING  : bRes = FALSE; dwErrCode = ERROR_BAD_FORMAT; break; // The class string was improperly formatted.
      case REGDB_E_WRITEREGDB: // The CLSID corresponding to the class string was not found in the registry.
      default:
         if (szGUID) {
            dwErrCode = ERROR_INVALID_DATA;
            //    GUID
            // 0         1         2         3
            // 01234567890123456789012345678901234567
            // {01234567-0123-0123-0123-0123456789AB}
            CString strGUID(szGUID);
            strGUID.MakeUpper();
            static TCHAR szABC[] = _T("0123456789ABCDEF");
            if ((strGUID.GetLength() != 38) ||
                (szGUID[ 0] != _T('{')) ||
                (szGUID[ 9] != _T('-')) ||
                (szGUID[14] != _T('-')) ||
                (szGUID[19] != _T('-')) ||
                (szGUID[24] != _T('-')) ||
                (szGUID[37] != _T('}')) /**/||
                (!strGUID.Mid( 1, 8).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(10, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(15, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(20, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(25,12).SpanExcluding(szABC).IsEmpty())/**/
               )
            {
            } else {
               strGUID.Replace(_T('{'), _T(' '));
               strGUID.Replace(_T('-'), _T(' '));
               strGUID.Replace(_T('}'), _T(' '));
               /**
               strGUID = strGUID.Mid( 1, 8) + //
                         strGUID.Mid(10, 4) + // + _T(" ")
                         strGUID.Mid(15, 4) + // + _T(" ")
                         strGUID.Mid(20, 2) + // + _T(" ")
                         strGUID.Mid(22, 2) + // + _T(" ")
                         strGUID.Mid(25, 2) + // + _T(" ")
                         strGUID.Mid(27, 2) + // + _T(" ")
                         strGUID.Mid(29, 2) + // + _T(" ")
                         strGUID.Mid(31, 2) + // + _T(" ")
                         strGUID.Mid(33, 2) + // + _T(" ")
                         strGUID.Mid(35, 2);  // + _T(" ")
               /**/
               int iData1=0, iData2=0, iData3=0, iData4[8] = {0,0,0,0,0,0,0,0};
               if (
         #ifdef _stscanf_s
                  _stscanf_s
         #else
                  _stscanf
         #endif
                   ((LPCTSTR)strGUID, _T("%08X%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X"),
                     &iData1, &iData2, &iData3,
                     &iData4[0], &iData4[1], &iData4[2], &iData4[3],
                     &iData4[4], &iData4[5], &iData4[6], &iData4[7]) == 11)
               {
                  guid.Data1 = iData1; guid.Data2 = iData2; guid.Data3 = iData3;
                  guid.Data4[0] = iData4[0];
                  guid.Data4[1] = iData4[1];
                  guid.Data4[2] = iData4[2];
                  guid.Data4[3] = iData4[3];
                  guid.Data4[4] = iData4[4];
                  guid.Data4[5] = iData4[5];
                  guid.Data4[6] = iData4[6];
                  guid.Data4[7] = iData4[7];
                  bRes = TRUE;
                  dwErrCode = ERROR_SUCCESS;
               } else {
                  dwErrCode = ERROR_INVALID_DATA; //::GetLastError();
               }
            }
         }
      } // switch
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

CString ErrCode2Str(DWORD dwErrCode, DWORD dwLanguageId) {
   CString strRes;
   LPTSTR lpMsgBuf = NULL;
   DWORD dwRes = ::FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
      NULL,
      dwErrCode,
      dwLanguageId,
      (LPTSTR)&lpMsgBuf,
      0,
      NULL
   );
   if (dwRes != 0) {
      strRes = lpMsgBuf;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   } else {
      //DWORD dwErrCode2 = ::GetLastError(); // must be ERROR_MR_MID_NOT_FOUND ???
   }
   if (lpMsgBuf)
      ::LocalFree(lpMsgBuf);
   /** /
   if (strRes.IsEmpty()) {
      if (dwErrCode & 0x80000000) {
         strRes.Format(_T("Unknown error 0x%08X"), dwErrCode);
      } else {
         strRes.Format(_T("Unknown error %i"), dwErrCode);
      }
   }
   /**/
   return strRes;
}

CString ErrCode2Str(IN HMODULE hModule, IN DWORD dwErrCode, DWORD dwLanguageId) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   CString strRes;
#ifndef __FILE__RESOURCES__
   #ifdef _DEBUG
      #pragma message("  >>>Please include 'Resources.h' to the project - add header to 'StdAfx.h' file...")
      {
         static bool bCall = false;
         if (!bCall) {
            bCall = true;
            ::OutputDebugString(_T("   !!! File CommonLib.cpp; func CString ErrCode2Str(IN HMODULE hModule, IN DWORD dwErrCode)\r\n"));
            ::OutputDebugString(_T("   >>>      'Resources.h'  'Resources.cpp'.    'StdAfx.h' #include 'Resources.h'\r\n"));
            ::OutputDebugString(_T("   >>> .. - FormatMessage    .\r\n"));
            ::OutputDebugString(_T("   >>>   NT  (  'ntdll.dll') STATUS_ACCESS_VIOLATION FormatMessage \r\n"));
            ::OutputDebugString(_T("   >>> 'The instruction at 0x'\r\n"));
            ::OutputDebugString(_T("   >>> \r\n"));
            ::OutputDebugString(_T("   >>> 'The instruction at 0x%08lx referenced memory at 0x%08lx. The memory could not be %s.'\r\n"));
            ::OutputDebugString(_T("   >>> ..   FormatMessage   ...\r\n"));
         }
      }
   #endif
#else
   { //    ...
      DWORD dwSize = 0;
      const BYTE *pResource = ::GetResource(hModule, RT_MESSAGETABLE, MAKEINTRESOURCE(1), dwLanguageId, dwSize);
      if (!pResource) {
         dwErrCodeRes = ::GetLastError();
      } else {
         dwErrCodeRes = ERROR_NOT_FOUND;
         MESSAGE_RESOURCE_DATA *pRD = (MESSAGE_RESOURCE_DATA*)pResource;
         for (DWORD i=0; i<pRD->NumberOfBlocks; i++) {
            MESSAGE_RESOURCE_BLOCK &Block = pRD->Blocks[i];
            if (dwErrCode >= Block.LowId && dwErrCode <= Block.HighId) { //   
               DWORD dwOffsetToEntries = Block.OffsetToEntries;
               for (DWORD j=Block.LowId; j<=Block.HighId; j++) {
                  _ASSERT_EXPR(dwOffsetToEntries < dwSize, L"can by Out of memory");
                  MESSAGE_RESOURCE_ENTRY &Entry = *(MESSAGE_RESOURCE_ENTRY*)(((BYTE*)pResource)+dwOffsetToEntries);
                  if (dwErrCode == j) { //  :)
                     if (Entry.Flags) {
                        // Unicode
                        strRes = (LPCWSTR)Entry.Text;
                     } else {
                        // ANSI
                        strRes = (LPCSTR)Entry.Text;
                     }
                     strRes.Replace(_T("\r\n"), _T(" "));
                     strRes.TrimRight();
                     dwErrCodeRes = NO_ERROR;
                     break;
                  }
                  dwOffsetToEntries += Entry.Length;
               }
               break;
            }
         }
      }
   }
   if (dwErrCodeRes != NO_ERROR) //      -    FormatMessage
#endif
   {
      LPTSTR szError = NULL;
      DWORD dwBaseLength = ::FormatMessage(
         FORMAT_MESSAGE_MAX_WIDTH_MASK | //  \r\n   
         FORMAT_MESSAGE_IGNORE_INSERTS |
         FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_HMODULE, // dwFlags
         hModule,                                                      // lpSource
         dwErrCode,                                                    // dwMessageId
         dwLanguageId,                                                 // dwLanguageId
         (LPTSTR)&szError,                                             // lpBuffer
         0,                                                            // nSize
         NULL );                                                       // * arguments

      if (dwBaseLength == 0) {
         dwErrCodeRes = ::GetLastError();
      } else {
         strRes = szError;
   #ifdef _DEBUG
         int iCount = strRes.Replace(_T("\r\n"), _T(" "));
         _ASSERT_EXPR(iCount == 0, L" FORMAT_MESSAGE_MAX_WIDTH_MASK   :(");
         strRes.TrimRight();
   #endif
      }
      if (szError) {
         ::LocalFree(szError);
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString ErrCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode, DWORD dwLanguageId) {
   CString strRes;
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   BOOL bLoadLibrary = FALSE;
   HMODULE hMod = ::GetLibrary(lpModuleName, TRUE, bLoadLibrary);
   if (!hMod) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = ErrCode2Str(hMod, dwErrCode, dwLanguageId);
      if (strRes.IsEmpty()) {
         dwErrCodeRes = ::GetLastError();
      }
      if (bLoadLibrary) {
         BOOL bRes = ::FreeLibrary(hMod);
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString WinInetErrCode2Str(DWORD dwErrCode, DWORD dwLanguageId) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   CString strRes = ErrCode2Str(_T("WinInet.dll"), dwErrCode, dwLanguageId);
   if (strRes.IsEmpty()) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = _T("Internet API error. ") + strRes;

      if (dwErrCode == ERROR_INTERNET_EXTENDED_ERROR) {
#ifdef EXCLUDE_STATIC_LINK_WININET_LIBRARY //    ,     WinInet.dll   -   ( - InternetGetLastResponseInfo)
         #ifdef _DEBUG
            _ASSERT_EXPR(FALSE, L"   !");
         #endif
#else
         DWORD dwInetError = 0;
         DWORD dwExtLength = 0;
         BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, NULL, &dwExtLength);
         DWORD dwErrCode2 = ::GetLastError();
         if ((dwErrCode2 != ERROR_INSUFFICIENT_BUFFER) || (dwExtLength==0)) {
            dwErrCodeRes = ::GetLastError();
         } else {
            TCHAR *szExtErrMsg = new TCHAR [dwExtLength = dwExtLength+1]; // + EOL
            if (szExtErrMsg == NULL) {
               dwErrCodeRes = ERROR_OUTOFMEMORY;
            } else {
               szExtErrMsg[0] = 0;
               BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, szExtErrMsg, &dwExtLength);
               if (!bRes) {
                  dwErrCodeRes = ::GetLastError();
               } else {
                  strRes += szExtErrMsg;
               }

               delete [] szExtErrMsg;
            }
         }
#endif
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString DosError2Str(int iDosErr) {
   CString strRes;
   {
      TCHAR szDosErr[128] = {0};
   #if (_MSC_VER >= 1400)
      int iErr2 = _tcserror_s(szDosErr, chDIMOF(szDosErr)-1,  iDosErr);
      if (iErr2 != 0) {
         _ASSERT_EXPR(FALSE, L"DosError2Str: _tcserror_s:  ?");
#pragma warning(disable:4996)
         strRes = _tcserror(iDosErr);
#pragma warning(default:4996)
      } else {
         strRes = szDosErr;
      }
   #else
      strRes = strerror(iDosErr);
   #endif
   }
   return strRes;
}

BOOL EnumFiles(IN LPCTSTR szDirName, IN LPCTSTR szMask, IN FILEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   if (!szDirName || !szDirName[0] || /*!szMask || !szMask[0] || */!lpEnumFunc) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   UINT iPos = 0;
   do {
      if (hFindFile == NULL) {
         hFindFile = ::FindFirstFile(strDirName + ((szMask && szMask[0]) ? szMask : _T("*")), &findFileData);
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (!(findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
            bRes &= lpEnumFunc(szDirName, findFileData.cFileName, iPos++, lpUserData);
         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EnumSubDir(IN LPCTSTR szDirName, IN DIRENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   if (!szDirName || !szDirName[0] || !lpEnumFunc) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   UINT iPos = 0;
   do {
      if (hFindFile == NULL) {
#if(_WIN32_WINNT >= 0x0400)
         hFindFile = ::FindFirstFileEx(strDirName + _T('*'), FindExInfoStandard, &findFileData, FindExSearchLimitToDirectories, NULL, 0);
         if (hFindFile == INVALID_HANDLE_VALUE)
#endif // (_WIN32_WINNT >= 0x0400)
         {
            hFindFile = ::FindFirstFile(strDirName + _T('*'), &findFileData);
         }
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            if (findFileData.cFileName[0]==_T('.') && (findFileData.cFileName[1]==_T('\0') ||
                                                      (findFileData.cFileName[1]==_T('.') && findFileData.cFileName[2]==_T('\0'))))
            {} else
            //if (lstrcmp(findFileData.cFileName, _T(".")) &&
            //    lstrcmp(findFileData.cFileName, _T("..")))
            {
               bRes &= lpEnumFunc(szDirName, findFileData.cFileName, iPos++, lpUserData);
            }

         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}
