////////////////////////////////////////////////////////////////////////////////
// File name: Helper.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: SeregaLBN@gmail.com
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru
// Date: 2010 12 06
//
// Description:  (-)  -
//              (   WinAPI)   
////////////////////////////////////////////////////////////////////////////////
//
//  ( ):
//    HELPER_DUMMY -  -.    exe/dll.
//    HELPER_NO_DESCRIPTION -     - (  bDescription).    exe/dll.
//
//      Helper.h(cpp),     
// #ifndef _DEBUG
//    #define HELPER_DUMMY
// #endif
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__TO_HELPER__
#define __FILE__TO_HELPER__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

#if !defined _WINTERNL_ || (_WIN32_WINNT < 0x0500) // see <winternl.h>
   typedef LONG NTSTATUS;
#endif _WINTERNL_

namespace nsHelper
{
   #if defined HELPER_CHAR_UNICODE
      typedef BOOL (CALLBACK* GUIDENUMPROC)(IN REFGUID guid, IN LPCWSTR szGUID, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
   #elif defined HELPER_CHAR_ANSI
      typedef BOOL (CALLBACK* GUIDENUMPROC)(IN REFGUID guid, IN LPCSTR  szGUID, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
   #else
      typedef BOOL (CALLBACK* GUIDENUMPROC)(IN REFGUID guid, IN LPCTSTR szGUID, IN LPVOID lpUserData); // if return FALSE -> stop enumerators
   #endif

   CString WindowMessage(UINT msg);         // Window Message to string
   CString WindowStyle  (HWND hWnd);        // Window Styles to string
   CString WindowStyle  (DWORD dwStyle, LPCTSTR szClassName = NULL); // Window Styles to string
   CString WindowStyleEx(HWND hWnd);        // Extended Window Styles to string
   CString WindowStyleEx(DWORD dwStyleEx);  // Extended Window Styles to string
   CString SetWindowPos (UINT flags);       // SetWindowPos Flags to string
   CString DialogCode   (int iCode);        // Dialog Code to string (see WM_GETDLGCODE)
   CString ButtonState  (int iState);       // State of the button to string (see BM_GETSTATE)

   BOOL EnumCLSIDsFromRegistry(IN nsHelper::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData);
   BOOL EnumIIDsFromRegistry  (IN nsHelper::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData);
   BOOL EnumGUIDs             (IN nsHelper::GUIDENUMPROC pEnumFunc, IN LPVOID lpUserData, BOOL bFromRegistry);

   CString EqualsGUIDs      (REFGUID  guid       , BOOL bFromRegistry, LPCTSTR szSeparator); //   GUID       guid.                                       ; #ifdef HELPER_DUMMY -    
   CString CoCreateInstances(REFCLSID clsid      , BOOL bFromRegistry, LPCTSTR szSeparator); //   IID,      CoCreateInstance    clsid.              ; #ifdef HELPER_DUMMY -    
   CString QueryInterfaces  (IUnknown *pInterface, BOOL bFromRegistry, LPCTSTR szSeparator); //   IID,      pInterface (  pInterface->QueryInterface(..)) ; #ifdef HELPER_DUMMY -    
   CString ProgID     (REFCLSID clsid); //    CLSID   LibraryName.CoClassName.Version,   .   ProgIDFromCLSID.
   CString InterfaceID(REFIID     iid); //    ,   .

   //   /,    
   CString ErrCode       (DWORD    dwErrCode, BOOL bDescription, BOOL bSysMsg = TRUE, DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) ); //  bDescription==TRUE  -   ;
   CString HResult       (HRESULT  hRes     , BOOL bDescription, BOOL bSysMsg = TRUE, DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) ); //          bDescription==FALSE -    
   CString NTStatus      (NTSTATUS lErrCode , BOOL bDescription, BOOL bSysMsg = TRUE, DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) ); //   bSysMsg - ,  ,    .
   CString WinInetErrCode(DWORD    dwErrCode, BOOL bDescription, BOOL bSysMsg = TRUE, DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) );
   CString WinHTTPErrCode(DWORD    dwErrCode, BOOL bDescription, BOOL bSysMsg = TRUE, DWORD dwLanguageId = MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT) );
   CString DosError      (int      iDosErr  , BOOL bDescription, BOOL bSysMsg = TRUE);

   inline HRESULT ErrCode2HResult(DWORD dwErrCode) { return HRESULT_FROM_WIN32(dwErrCode); }
   inline DWORD   HResult2ErrCode(HRESULT hRes   ) { return HRESULT_CODE(hRes); } // Returns the error code part of the HRESULT.
   inline HRESULT NTStatus2HResult(NTSTATUS lErrCode) { return FILTER_HRESULT_FROM_FLT_NTSTATUS(lErrCode); } // NTSTATUS --> HRESULT

   CString QueryInfoFlag           (IN DWORD dwOption);              // convert WinInetApi HTTP Query flag to string, for detail see IWinInetHttpInfo::QueryInfo
   CString QueryOption             (IN DWORD dwOption);              // convert QUERYOPTION to string, for detail see IWinInetInfo::QueryOption or IInternetProtocolInfo::QueryInfo Method
   CString ParseAction             (IN DWORD dwParseAction);         // convert PARSEACTION to string, for detail see IInternetProtocolInfo::ParseUrl Method
   CString InternetCombineUrlFlags (IN DWORD dwCombineFlags);        // convert ICU_xxx flag to string, for detail see InternetCanonicalizeUrl or InternetCombineUrl or InternetCrackUrl or InternetCreateUrl or IInternetProtocolInfo::CombineUrl Method
   CString SystemTime(const SYSTEMTIME &st, BOOL bDate, BOOL bTime); // convert to string as YYYY.MM.DD HH:MM:SS,MS
   CString BindFlag(IN DWORD dwBINDF);                               // convert BINDF flag to string
   CString BindStatusCallbackFlag(IN DWORD grfBSCF);                 // convert BSCF flag to string
   CString BindString(IN ULONG ulStringType);                        // convert BINDSTRING to string
   CString BindStatus(IN ULONG ulStatusCode);                        // convert BINDSTATUS to string

   CString StringArray(IN LPCOLESTR const *const ppwzStr, IN ULONG uSize, LPCTSTR szLeft = _T("["), LPCTSTR szRight = _T("]"), LPCTSTR szSeparator = _T(", ")); // convert string array to string as   [string1], [string2], [string3], ... [stringN]

   CString InternetStatusCallback(DWORD dwInternetStatus, BOOL bWinHTTP = FALSE); // convert Internet status callback flag to string
   CString WinHTTPCallbackStatusRequestError(DWORD dwValue, BOOL bDescription);
   CString WinHTTPCallbackStatusSecureFailure(DWORD dwValue, BOOL bDescription);
   CString HTTPStatusCode(DWORD dwHTTPStatus, BOOL bDescription);

   CString PrinterStatus    (DWORD dwStatus);
   CString PrinterAttributes(DWORD dwAttributes);
   CString PrinterJobStatus (DWORD dwJobStatus);

   CString ServiceState(DWORD dwStatus);

   CString ExceptionCode(DWORD dwExceptionCode, BOOL bDescription);

   CString ShellExec(HINSTANCE hInst, BOOL bDescription); // description ShellExecute Win32 API function

   CString ResourceType(LPCTSTR lpszType, BOOL bDescription);

   CString OwnerDrawCtlType   (UINT iCtlType);
   inline CString OwnerDrawCtlType   (const DRAWITEMSTRUCT    &di) { return OwnerDrawCtlType(di.CtlType); }
   inline CString OwnerDrawCtlType   (const MEASUREITEMSTRUCT &mi) { return OwnerDrawCtlType(mi.CtlType); }
   CString OwnerDrawItemAction(UINT itemAction);
   inline CString OwnerDrawItemAction(const DRAWITEMSTRUCT &di) { return OwnerDrawItemAction(di.itemAction); }
   CString OwnerDrawItemState (UINT itemState);
   inline CString OwnerDrawItemState (const DRAWITEMSTRUCT &di) { return OwnerDrawItemState(di.itemState); }
}

#endif // __FILE__TO_HELPER__
