////////////////////////////////////////////////////////////////////////////////
// File name: Bitmap.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru/Bitmap.html
// Date: 2010 11 01
//
// Description:   BMP
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2007-2010 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__BITMAPS__
#define __FILE__BITMAPS__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

#include "../Resources.h"

SIZE SizeBitmap(HDC hDC);
SIZE SizeBitmap(HBITMAP hBmp);
SIZE SizeBitmap(LPCTSTR szBmpFile);
SIZE SizeBitmap(HMODULE hMod, LPCTSTR szResourceName); //  bitmap'      RT_BITMAP
SIZE SizeBitmap(HMODULE hMod, LPCTSTR szResourceName, WORD wIDLanguage); //  bitmap'      RT_BITMAP c  

DWORD BitmapDibSectionSize(const BITMAPINFOHEADER &);

WORD GetBitmapLang(HMODULE hMod, LPCTSTR szResourceName); //    bitmap'      RT_BITMAP (   bitmap' )
WORD GetBitmapCount(HMODULE hMod, BOOL bLang); //  bitmap  DLL/EXE ( bLang==FALSE  -  RT_BITMAP). bLang -     bitmap'

BOOL GetBitmapGroupNames(  IN HMODULE hMod, OUT CRcName   *pNames, IN OUT WORD &wLenBuf); //      RT_BITMAP
BOOL GetBitmapGroupNamesEx(IN HMODULE hMod, OUT CRcNameEx *pNames, IN OUT WORD &wLenBuf); //      RT_BITMAP   

// save uncompressed bitmap
BOOL SaveBitmap(HDC hDC,               LPCTSTR szBmpFile, BOOL bReplaceFile = TRUE); // bitmap from memory HDC
BOOL SaveBitmap(         HBITMAP hBmp, LPCTSTR szBmpFile, BOOL bReplaceFile = TRUE); // ! hBmp must by not assigned with HDC
BOOL SaveBitmap(HDC hDC, HBITMAP hBmp, LPCTSTR szBmpFile, BOOL bReplaceFile = TRUE);

// loads
HBITMAP LoadBitmap(LPCTSTR szBmpFile); //  bitmap'  
HBITMAP LoadBitmapEx(HMODULE hMod, LPCTSTR szResourceName);                 //  bitmap'      RT_BITMAP (   API LoadBitmap)
HBITMAP LoadBitmap(HMODULE hMod, LPCTSTR szResourceName, WORD wIDLanguage); //  bitmap'      RT_BITMAP   
HBITMAP LoadBitmap(const BITMAPINFO *pBmpI, DWORD nbSize);
HBITMAP LoadBitmap(const BITMAPFILEHEADER *pBmpFH, DWORD nbSize);

BOOL ExtractBmp( //  bitmap'  RT_BITMAP  bmp-
   IN HMODULE hMod,
   IN LPCTSTR szResourceName, //  bitmap'   RT_BITMAP
   IN LPCTSTR szBmpFile       //        (   !)
);
BOOL ExtractBmp( //  bitmap'  RT_BITMAP  bmp-   
   IN HMODULE hMod,
   IN LPCTSTR szResourceName, //  bitmap'   RT_BITMAP
   IN WORD wIDLanguage,
   IN LPCTSTR szBmpFile       //        (   !)
);

//  HBITMAP.  32   -    
// Paint HBITMAP. For 32-bit images - use alpha channel
BOOL DrawBitmap(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, POINT const &pLTSrc); // BitBlt
BOOL DrawBitmap(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, RECT  const & rcSrc); // StretchBlt

HBITMAP CreateCompatibleBitmap(HBITMAP, int iWidth, int iHeight);
HBITMAP CreateBitmap(int iWidth, int iHeight);  // create compatible bitmap at desktop
HBITMAP CreateBitmapMono(const SIZE &sizeBmp);  // create monohrome bitmap
HBITMAP CreateBitmapMask(HBITMAP hBmp, COLORREF colorTransparent = CLR_INVALID); // create monohrome bitmap from color bitmap. hBmp     HDC
HBITMAP CreateBitmapRotated(HBITMAP hBitmap, float angle, COLORREF clrBack = CLR_INVALID /* Pixel(0,0) */);

#endif // __FILE__BITMAPS__
