////////////////////////////////////////////////////////////////////////////////
// File name: DC.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru
// Date: 2010 11 19
//
// Description: ,   HDC
////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2007-2010 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h" //     MFC /  Precompiled Headers

#include "DC.h"
#include "Bitmap.h"

// raster operation code
#define DSx  0x00660046L
#define DSna 0x00220326L

#define BltOperBegin \
   HDC hDCSrc = ::CreateCompatibleDC(hDCDst); \
   HGDIOBJ hBmpOld = ::SelectObject(hDCSrc, hBmpSrc); \
   DWORD dwErrCode = NO_ERROR
#define BltOperEnd \
   if (!bRes) \
      dwErrCode = ::GetLastError(); \
   ::SelectObject(hDCSrc, hBmpOld); \
   ::SetLastError(dwErrCode)
////////////////////////////////////////////////////////////////////////////////

inline RECT MaxMinXY(const POINT *pP, int nCount) {
   RECT rc = {0,0,0,0};
   for (int i=0; pP && i<nCount; i++) {
      if (rc.left   > pP[i].x) rc.left   = pP[i].x;
      if (rc.top    > pP[i].y) rc.top    = pP[i].y;
      if (rc.right  < pP[i].x) rc.right  = pP[i].x;
      if (rc.bottom < pP[i].y) rc.bottom = pP[i].y;
   }
   return rc;
}

BOOL BitBlt(HDC hDCDst, const RECT &rectDst, HDC hDCSrc, const POINT &pointTopLeft, DWORD dwROp) {
   return ::BitBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, pointTopLeft.x, pointTopLeft.y, dwROp);
}
BOOL BitBlt(HDC hDCDst, const RECT &rectDst, HBITMAP hBmpSrc, const POINT &pointTopLeft, DWORD dwROp) {
//   return ::DrawBitmapEx(hDCDst, rectDst, hBmpSrc, pointTopLeft);
   BltOperBegin;
   BOOL bRes = ::BitBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, pointTopLeft.x, pointTopLeft.y, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL BitBlt(HDC hDCDst, const RECT &rectDst, HDC hDCSrc, DWORD dwROp) {
   return ::BitBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, 0, 0, dwROp);
}
BOOL BitBlt(HDC hDCDst, const RECT &rectDst, HBITMAP hBmpSrc, DWORD dwROp) {
//   POINT pSrc = {0, 0};
//   return ::DrawBitmapEx(hDCDst, rectDst, hBmpSrc, pSrc);
   BltOperBegin;
   BOOL bRes = ::BitBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, 0, 0, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL BitBlt(HDC hDCDst, const SIZE &sizeDst, HDC hDCSrc, const POINT &pointTopLeft, DWORD dwROp) {
   return ::BitBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, pointTopLeft.x, pointTopLeft.y, dwROp);
}
BOOL BitBlt(HDC hDCDst, const SIZE &sizeDst, HBITMAP hBmpSrc, const POINT &pointTopLeft, DWORD dwROp) {
//   RECT rcDst = {0, 0, sizeDst.cx, sizeDst.cy};
//   return ::DrawBitmapEx(hDCDst, rcDst, hBmpSrc, pointTopLeft);
   BltOperBegin;
   BOOL bRes = ::BitBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, pointTopLeft.x, pointTopLeft.y, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL BitBlt(HDC hDCDst, const SIZE &sizeDst, HDC hDCSrc, DWORD dwROp) {
   return ::BitBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, 0, 0, dwROp);
}
BOOL BitBlt(HDC hDCDst, const SIZE &sizeDst, HBITMAP hBmpSrc, DWORD dwROp) {
//   RECT rcDst = {0, 0, sizeDst.cx, sizeDst.cy};
//   POINT pSrc = {0, 0};
//   return ::DrawBitmapEx(hDCDst, rcDst, hBmpSrc, pSrc);
   BltOperBegin;
   BOOL bRes = ::BitBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, 0, 0, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL StretchBlt(HDC hDCDst, const RECT &rectDst, HDC hDCSrc, const RECT &rectSrc, DWORD dwROp) {
   return ::StretchBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, rectSrc.left, rectSrc.top, rectSrc.right-rectSrc.left, rectSrc.bottom-rectSrc.top, dwROp);
}
BOOL StretchBlt(HDC hDCDst, const RECT &rectDst, HBITMAP hBmpSrc, const RECT &rectSrc, DWORD dwROp) {
//   return ::DrawBitmapEx(hDCDst, rectDst, hBmpSrc, rectSrc);
   BltOperBegin;
   BOOL bRes = ::StretchBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, rectSrc.left, rectSrc.top, rectSrc.right-rectSrc.left, rectSrc.bottom-rectSrc.top, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL StretchBlt(HDC hDCDst, const RECT &rectDst, HDC hDCSrc, const SIZE &sizeSrc, DWORD dwROp) {
   return ::StretchBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, 0, 0, sizeSrc.cx, sizeSrc.cy, dwROp);
}
BOOL StretchBlt(HDC hDCDst, const RECT &rectDst, HBITMAP hBmpSrc, const SIZE &sizeSrc, DWORD dwROp) {
//   RECT rcSrc = {0, 0, sizeSrc.cx, sizeSrc.cy};
//   return ::DrawBitmapEx(hDCDst, rectDst, hBmpSrc, rcSrc);
   BltOperBegin;
   BOOL bRes = ::StretchBlt(hDCDst, rectDst.left, rectDst.top, rectDst.right-rectDst.left, rectDst.bottom-rectDst.top, hDCSrc, 0, 0, sizeSrc.cx, sizeSrc.cy, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL StretchBlt(HDC hDCDst, const SIZE &sizeDst, HDC hDCSrc, const SIZE &sizeSrc, DWORD dwROp) {
   return ::StretchBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, 0, 0, sizeSrc.cx, sizeSrc.cy, dwROp);
}
BOOL StretchBlt(HDC hDCDst, const SIZE &sizeDst, HBITMAP hBmpSrc, const SIZE &sizeSrc, DWORD dwROp) {
//   RECT rcDst = {0, 0, sizeDst.cx, sizeDst.cy};
//   RECT rcSrc = {0, 0, sizeSrc.cx, sizeSrc.cy};
//   return ::DrawBitmapEx(hDCDst, rcDst, hBmpSrc, rcSrc);
   BltOperBegin;
   BOOL bRes = ::StretchBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, 0, 0, sizeSrc.cx, sizeSrc.cy, dwROp);
   BltOperEnd;
   return bRes;
}

BOOL StretchBlt(HDC hDCDst, const SIZE &sizeDst, HDC hDCSrc, const RECT &rectSrc, DWORD dwROp) {
   return ::StretchBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, rectSrc.left, rectSrc.top, rectSrc.right-rectSrc.left, rectSrc.bottom-rectSrc.top, dwROp);
}
BOOL StretchBlt(HDC hDCDst, const SIZE &sizeDst, HBITMAP hBmpSrc, const RECT &rectSrc, DWORD dwROp) {
//   RECT rcDst = {0, 0, sizeDst.cx, sizeDst.cy};
//   return ::DrawBitmapEx(hDCDst, rcDst, hBmpSrc, rectSrc);
   BltOperBegin;
   BOOL bRes = ::StretchBlt(hDCDst, 0, 0, sizeDst.cx, sizeDst.cy, hDCSrc, rectSrc.left, rectSrc.top, rectSrc.right-rectSrc.left, rectSrc.bottom-rectSrc.top, dwROp);
   BltOperEnd;
   return bRes;
}


BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, RECT const &rcSrc, HDC hDCMsk, RECT const &rcMsk) {
   DWORD dwErrCode = NO_ERROR;

   COLORREF oldBkColor   = ::SetBkColor  (hDCDst, RGB(255, 255, 255));
   COLORREF oldTextColor = ::SetTextColor(hDCDst, RGB(0, 0, 0));
   BOOL bRes = ::SetStretchBltMode(hDCDst, COLORONCOLOR) &&
               ::StretchBlt(hDCDst, rcDst, hDCSrc, rcSrc, DSx ) &&
               ::StretchBlt(hDCDst, rcDst, hDCMsk, rcMsk, DSna) &&
               ::StretchBlt(hDCDst, rcDst, hDCSrc, rcSrc, DSx );
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::SetBkColor  (hDCDst, oldBkColor);
   ::SetTextColor(hDCDst, oldTextColor);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, HDC hDCMsk, POINT const &pLTMsk) {
   DWORD dwErrCode = NO_ERROR;

   COLORREF oldBkColor   = ::SetBkColor  (hDCDst, RGB(255, 255, 255));
   COLORREF oldTextColor = ::SetTextColor(hDCDst, RGB(0, 0, 0));
   BOOL bRes = ::BitBlt(hDCDst, rcDst, hDCSrc, pLTSrc, DSx ) &&
               ::BitBlt(hDCDst, rcDst, hDCMsk, pLTMsk, DSna) &&
               ::BitBlt(hDCDst, rcDst, hDCSrc, pLTSrc, DSx );
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::SetBkColor  (hDCDst, oldBkColor);
   ::SetTextColor(hDCDst, oldTextColor);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, RECT const &rcSrc , COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;

   HDC hDCSrc = ::CreateCompatibleDC(hDCDst);
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = ::CreateBitmapMask(hBmpSrc, clrTransparent);
   HGDIOBJ hBmpMskOld  = ::SelectObject(hDCMsk, hBmpMsk);
   HGDIOBJ hBmpSrcOld  = ::SelectObject(hDCSrc, hBmpSrc);

   BOOL bRes = ::StretchBltMasked(hDCDst, rcDst, hDCSrc, rcSrc, hDCMsk, rcSrc);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }

   ::SelectObject(hDCMsk, hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::SelectObject(hDCSrc, hBmpSrc);
   ::DeleteDC(hDCSrc);
   ::DeleteObject(hBmpMsk);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, POINT const &pLTSrc, COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;

   // 1.    
   HDC hDCSrc = ::CreateCompatibleDC(hDCDst);
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = ::CreateBitmapMask(hBmpSrc, clrTransparent);
   HGDIOBJ hBmpMskOld  = ::SelectObject(hDCMsk, hBmpMsk);
   HGDIOBJ hBmpSrcOld  = ::SelectObject(hDCSrc, hBmpSrc);
   // 2.   
   BOOL bRes = ::BitBltMasked(hDCDst, rcDst, hDCSrc, pLTSrc, hDCMsk, pLTSrc);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }

   ::SelectObject(hDCMsk, hBmpMskOld);
   ::SelectObject(hDCSrc, hBmpSrcOld);
   ::DeleteObject(hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::DeleteDC(hDCSrc);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;

   // 1.   hDCSrc 
   HBITMAP hBmpSrc = ::CreateCompatibleBitmap(hDCSrc, rcDst.right-rcDst.left, rcDst.bottom-rcDst.top);
   {
      HDC hCDC = ::CreateCompatibleDC(hDCSrc);
      HGDIOBJ hBmpOld = ::SelectObject(hCDC, hBmpSrc);
      ::BitBlt(hCDC, 0,0,rcDst.right-rcDst.left, rcDst.bottom-rcDst.top, hDCSrc, pLTSrc.x,pLTSrc.y, SRCCOPY);
      ::SelectObject(hCDC, hBmpOld);
      ::DeleteDC(hCDC);
   }
   // 2.   
   //BOOL bRes = BitBltMasked(hDCDst, rcDst, hBmpSrc, pLTSrc, clrTransparent); // , .. hBmpSrc  ...
   BOOL bRes = BitBltMasked(hDCDst, rcDst, hBmpSrc, POINTEX(), clrTransparent);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::DeleteObject(hBmpSrc);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, RECT const &rcSrc, POINT const *pPointsMsk, int nCount, RECT const &rcMsk, bool bStretch) {
   DWORD dwErrCode = NO_ERROR;

   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = NULL;
   HGDIOBJ hBmpMskOld  = NULL;

   RECT rcMskFrame = MaxMinXY(pPointsMsk, nCount); rcMskFrame.left = rcMskFrame.top = 0;

   int iWidth  = rcMskFrame.right-rcMskFrame.left;
   int iHeight = rcMskFrame.bottom-rcMskFrame.top;
   BOOL bRes = !!(hBmpMsk = ::CreateBitmap(iWidth, iHeight, 1, 1, NULL)); //  bitmap  
   if (!bRes) {
      dwErrCode = ::GetLastError();
   } else {
      hBmpMskOld = ::SelectObject(hDCMsk, hBmpMsk); //       
      bRes = ::PatBlt(hDCMsk, 0,0, iWidth, iHeight, BLACKNESS); //  
      if (!bRes) {
         dwErrCode = ::GetLastError();
      } else {
         HGDIOBJ hBrushOld = ::SelectObject(hDCMsk, ::GetStockObject(WHITE_BRUSH));
         HGDIOBJ hPenOld   = ::SelectObject(hDCMsk, ::GetStockObject(NULL_PEN));
         bRes = ::Polygon(hDCMsk, pPointsMsk, nCount); //     
         if (!bRes) {
            dwErrCode = ::GetLastError();
         }
         ::SelectObject(hDCMsk, hBrushOld);
         ::SelectObject(hDCMsk, hPenOld);
      }
   }
   if (bRes) {
      if (bStretch) {
         bRes = ::StretchBltMasked(hDCDst, rcDst, hDCSrc, rcSrc, hDCMsk, rcMsk);
      } else {
         POINT pLTSrc = {rcSrc.left-rcSrc.right, rcSrc.bottom-rcSrc.top};
         POINT pLTMsk = {rcMsk.left-rcMsk.right, rcMsk.bottom-rcMsk.top};
         bRes = ::BitBltMasked(hDCDst, rcDst, hDCSrc, pLTSrc, hDCMsk, pLTMsk);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
      }
   }

   ::SelectObject(hDCMsk, hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::DeleteObject(hBmpMsk);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, RECT const &rcSrc, POINT const *pPointsMsk, int nCount, RECT const &rcMsk) {
   return BltMasked(hDCDst, rcDst, hDCSrc, rcSrc, pPointsMsk, nCount, rcMsk, true);
}
BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, POINT const *pPointsMsk, int nCount, POINT const &pLTMsk) {
   RECT rcSrc = {0, 0, pLTSrc.x, pLTSrc.y};
   RECT rcMsk = {0, 0, pLTMsk.x, pLTMsk.y};
   return BltMasked(hDCDst, rcDst, hDCSrc, rcSrc, pPointsMsk, nCount, rcMsk, false);
}



/*
http://forum.shelek.ru/index.php/topic,620.0.html
  .. ROP- (Raster operation code)

n    - ,    (Brush)
      GDI       .
   ,     .     
,            
.    ""    not or and xor. , 
  ,     .

  .
    D (Destination bitmap),
    (attern)
    S (Source bitmap)

       (      -  ):
:
   P S D
   -----
   0 0 0
   0 0 1
   0 1 0
   0 1 1
   1 0 0
   1 0 1
   1 1 0
   1 1 1

  .     ""   ,   
 1,   0. ..  ,       (S),   1
  (D)  .     1  :
:

 1.
	P S D 1
	-----
	0 0 0
	0 0 1
	0 1 0 0
	0 1 1 1
	1 0 0
	1 0 1
	1 1 0 0
	1 1 1 1

   (  )    . ..    
    P      2:
:

 2.
	P S D 1 2
	-----
	0 0 0   0	
	0 0 1   0
	0 1 0 0
	0 1 1 1
	1 0 0   1
	1 0 1   1
	1 1 0 0
	1 1 1 1

c  1  2       1011 1000 = 0xB8.  
   (     MSDN "boolean function")   
  ,    (   - 16 )  
.     .  (32 ).
   .        
 (       )     (MSDN "Platform SDK:
Windows GDI" "Ternary Raster Operations").
http://msdn.microsoft.com/en-us/library/aa932106.aspx
http://www.evmsoft.net/ru/roptest.html
http://software.intel.com/ru-ru/articles/extended-raster-operations-set/

        08     
ROP  - 0x00B8074A.
       "" , . SRCCOPY - 0x00CC0020
     ,   .

*/