////////////////////////////////////////////////////////////////////////////////
// File name: Resources.h
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// Date: 2008 08 27
//
// Description:   
// Copyright (C) 2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__RESOURCES__
#define __FILE__RESOURCES__

#if _MSC_VER > 1000
   #pragma once
#endif // _MSC_VER > 1000

const BYTE* GetResource( //     
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   OUT DWORD &dwSize
);
const BYTE* GetResource( //     
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD wLanguage,
   OUT DWORD &dwSize
);
BOOL ExtractResource( //      
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN LPCTSTR szFileName
);
BOOL ExtractResource( //         
   IN HMODULE hModule,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD    wLanguage,
   IN LPCTSTR szFileName
);

WORD GetResourceCount    (HMODULE hMod, BOOL bLang); //        (bLang -   )
WORD GetResourceTypeCount(HMODULE hMod); //  
WORD GetResourceNameCount(HMODULE hMod, LPCTSTR szResourceType, BOOL bLang); //      (bLang -    )
WORD GetResourceLangCount(HMODULE hMod, LPCTSTR szResourceType, LPCTSTR szResourceName); //     (     )

struct CRcType { WORD m_wType; CString m_strType; CRcType() : m_wType(0) {} };
struct CRcName { WORD m_wName; CString m_strName; CRcName() : m_wName(0) {} };
struct CRcLang { WORD m_wIDLanguage;              CRcLang() : m_wIDLanguage(0) {} };
struct CRcNameEx: public CRcName, CRcLang {};
struct CRc      : public CRcType, CRcName {};
struct CRcEx    : public CRcType, CRcName, CRcLang {};
BOOL GetResources        (IN HMODULE hMod,                                                       OUT CRc       *pResources, IN OUT WORD &wLenBuf); //       
BOOL GetResourcesEx      (IN HMODULE hMod,                                                       OUT CRcEx     *pResources, IN OUT WORD &wLenBuf); //          
BOOL GetResourceTypes    (IN HMODULE hMod,                                                       OUT CRcType   *pTypes    , IN OUT WORD &wLenBuf); //    
BOOL GetResourceNames    (IN HMODULE hMod, IN LPCTSTR szResourceType,                            OUT CRcName   *pNames    , IN OUT WORD &wLenBuf); //       
BOOL GetResourceNamesEx  (IN HMODULE hMod, IN LPCTSTR szResourceType,                            OUT CRcNameEx *pNames    , IN OUT WORD &wLenBuf); //          
BOOL GetResourceLanguages(IN HMODULE hMod, IN LPCTSTR szResourceType, IN LPCTSTR szResourceName, OUT CRcLang   *pLanguages, IN OUT WORD &wLenBuf); //      

//  
BOOL AddResource(IN LPCTSTR szModule, IN WORD    wResType , IN WORD    wResName, IN WORD wLang, IN const BYTE* pbData, IN DWORD cbSizeData);
BOOL DelResource(IN LPCTSTR szModule, IN LPCTSTR szResType, IN LPCTSTR szResName, IN WORD wLang);
BOOL DelResource(IN LPCTSTR szModule, IN WORD    wResType , IN WORD    wResName, IN WORD wLang);
WORD FindNewResouceName(IN HMODULE hMod    , IN LPCTSTR szType); //  ,   ,    
WORD FindNewResouceName(IN LPCTSTR szModule, IN LPCTSTR szType); //     (. GetLastError)

#endif // __FILE__RESOURCES__
